/*************************************
 MultiLauncher 0.3.0 background tasks
 (C) 2005-2007 Hynek Sladky
 sladky@mujmail.cz
*************************************/

#define ALLOW_ACCESS_TO_INTERNALS_OF_WINDOWS
#define ALLOW_ACCESS_TO_INTERNALS_OF_FORMS
#define ALLOW_ACCESS_TO_INTERNALS_OF_FIELDS

#include <PalmOS.h>
#include <PalmChars.h>
// ------------------------------------
// Handspring/Treo specific includes
// ------------------------------------
#include <PmSysGadgetLib.h>
#include <PmSysGadgetLibCommon.h>
#include <HsCreators.h>
#include <HsChars.h>
#include <HsKeyCodes.h>
#include <HsExt.h>
#include <HsKeyTypes.h>
#include <HsPhone.h>
#include <TonesLibTypes.h>
#include <TonesLib.h>
// ------------------------------------
// other includes
// ------------------------------------
#include <ByteOrderUtils.h>
#include <PalmOneCreators.h>
// ------------------------------------
// resources header
// ------------------------------------
#include "MLaunchR.h"
#include "MLaunch.h"
// ------------------------------------
// defines
// ------------------------------------
//#define UP_DOWN_SELECT                // povoli oznacovani bloku textu po radkach

/******** ToDo ********/
/**********************
OPRAVY:
======
- obcas se rano nespusti DDP&PE
  stava se to, pokud se automaticky vypne mobil a pak uz na Palm nesaham
  mozna to je spis pokud jsem ho vypnul rucne a tak se vypnuti neprovedlo?
  - podivat se, zda se regulerne ukonci uloha, pokud se Palm vypnul a ve Ftr zustala nedokoncena uloha...
    nebo zda nedochazi k tomu, ze takto otevrena uloha se dokonci misto nejake jine...

UPRAVY:
======
- podpora pro REM sleep
  asi nejlepe v dialogu nastaveni podsviceni - stisk urcite klavesy ukonci dialog a prejde do REM sleepu
  REMsleep: hsNotifyRemSleepRequestEvent
    ((SleepEventParamType*)(((SysNotifyParamType*)cmdPBP)->notifyDetailsP))->deferSleep++;
  tak nevim, jak to do dialogu dat: bud checkbox nebo???
  a jak tuto vlastnost vypnout? Pro prakticke pouziti by bylo rozumne, kdyby to bylo automaticky funkcni jen v CacheMate
  jednorazove zapnuti by bylo v terenu dost neprakticke...
  -> to vypada, ze by bylo nejlepsi udelat jednoucelovou aplikaci, ktera toto zaridi:
     - pri spusteni CacheMate se zaregistruje notifikace
     - pri spusteni jine aplikace se odregistruje notifikace
     - pri spusteni nebo pri resetu se zaregistruje notifikace pro AppLaunchEvent
       pripadne muzu na formular dat checkbox pro povoleni a zakazani, coz by bylo rozumne...

- take by tam mohlo byt rychle vypnuti podsviceni klavesnice a ukonceni dialogu - pro snadne cteni
  mozna by slo pridat (i) pro zobrazeni HELPu k temto ruznym funkcim...

- automaticke zapnuti telefonu nespusti spravne domovskou sit!
  misto nazvu providera se pise 'only SOS calls'
  pomuze rucne zmenit sit...
  - zkusil jsem prepnout do aplikace telefonu
  - mozna zkusim odemknout keyguard
  - pokud to nepomuze, tak uz nevim...
  - jeste zkusim poslat klavesu (dlouhe drzeni Power, jestli to jde...)
  -> zkusit se zeptat na foru

- FindAlarm vraci cas posunuty o +12s, aby nezacinal v celou minutu (zatim zakazano, nez overim, ze to bude bez problemu)
  - ma se to tykat jen task_TIME, ale snad nebude vadit, kdyz to bude i pro ostatni???

- jak to bude, kdyz bude zapnuty keylock pri tasku? asi by bylo vhodne ho deaktivovat...
  jenze nevim:
  a) jak se pozna, ze je aktivni
  b) jak se programove deaktivuje
  co tohle? nasel jsem to v kodu...
           HsAttrGet (hsAttrKeyboardLocked, 0, &val);
           val=!val;
           HsAttrSet (hsAttrKeyboardLocked, 0, &val);
  - dat toto jako moznost kroku!!!
    protoze KeyGuard je normalni smycka, ktera si jen nastavi AutoOff na cca 3s
    jinak normalne zpracovava eventy (ale stisk tlacitka apod. asi nepusti do aplikace...)
    takze je potreba v jistych pripadech toto umoznit...

- pokud je stav telefonu shodny s pozadovanym, tak se dalsi krok (je-li), provede ihned...
  tj. potlaci se delay pred dalsim krokem
  nojo, jenze ExecStep provede jen jeden krok...
  takze by se to muselo cele dat do jedne funkce...
  treba by to slo udelat pres navratovy kod: funkce OK, funkce preskocena, error...
- pokud je stav GSM shodny s pozadovanym, tak se nic nevola a krok se preskoci (vcetne pripadneho cekani na dalsi krok!)...
- pri event-keyDown-PowerOff se podivat, jestli bylo zapnuto tlacitkem nebo ne
  pokud bylo zapnuto bez tlacitka (asi alarm), tak se odesle
  pokud bylo zapnuto tlacitkem (asi prave uzivatel Palm pouziva), tak se neodesle...
  - pripadne by slo nastavit nejakym zpusobem AutoOff timer...
    - pokud potrebuju vypnout za urcity cas (neni-li uzivatelska aktivita), musim pouzit funkci EvtSetAutoOffTimer
      funkce SysSetAutoOffTime se pouziva pri boot a pri zmene preferenci (prefAutoOffDuration/prefAutoOffDuratioSecs)
      funkce EvtResetAutoOffTimer se muze pouzit k nulovani citace (tj. bude citat po celou nastavenou dobu)
- nekontroluje se nastaveni System Sound Volume (pripadne dalsi hlasitosti?)

- zjistit, jak menit stav BT (On/Off)
  BtLibOpen will run bluetooth on (you may open bluetooth library and then close it)
  disassemble the BT control panel

x pro HiRes prepocitat souradnice penUp
  - zatim bych to videl tak, ze kdyz to bude na HiRes, tak si to uzivatel nastavi sam...
    navic by bylo nejjednodussi upravit funkci AddPoint, jenze to by znamenalo vicenasobne volani nasledujicich funkci...
    tak to zatim opravdu necham na uzivateli
  FtrGet (sysFtrCreator, sysFtrNumWinVersion, &version);
  if (version>=4) {
    WinScreenGetAttribute (winScreenDensity, &attr);
    (attr/kDensitySingle) = 1.0/1.5/2.0 ...

- problemy s oznacovanim bloku:
  - nefunguje prepocitani scrollbaru pri posunuti fieldu!!!
  - setinspt zrusi blok, setselection vytvori blok, takze je to pomale a stale to blika
    (mozna to rychlejsi nebude kvuli rychlosti-pomalosti autorepeat?)
  - kdyz jsem to predelal podle svych myslenek, tak prestalo fungovat scrollovani fieldu - mimo viditelnou cast se vyber rozsiruje, ale neni to videt!!!
  - nefunguje oznacovani bloku po radkach!!!
    hlasi to pristup na fieldtype offset 20 (.lines) size 4 value FEFEFEFE (to je podivna hodnota!)
- oznacovani celych radek? (shift+up/down)
  nechat field zpracovat insPt, precist si ho a zmenit selection...?
  ale to by zrejme vyzadovalo poslat tuto klavesu 2x: prvni zrusi selection a zustane na konci/zacatku, druhy teprve provede meziradkovy prechod
  co jsem zjistil, tak meziradkovy prechod je zalozeny na poctu znaku od zacatku radku! ne na LCD pozici...
  Field nejak obsahuje LineInfoType strukturu (zrejme ve forme pole...)
  FldGlueGetLineInfo (fld, linenum, &start, &length) = true/false
  FieldType->lines[] pro kazdy viditelny radek (FldGetVisibleLines)
  -> zatim nefunguje (v simulatoru...)
- funkce pri drzeni up/down?
  provadet page up/down scrollovani fieldu?
  standardni funkce provadi posun kurzoru o jeden radek (krome QEDu, kde me to stve!)

- a dalsi vec: v ContrastPopup zobrazovat stav Aku/BT/GSM/Ir pouzitim std. gadgetu...
? vypada to, ze keyDown se transformuje na keyUp tesne pred GetEvent!!!
    eventDequeued je jeste keyDown, ale po GetEvent je keyUp...

TASKS:
======
- hit control (CtlHitControl)
- tap display (penDown/Up event - viz CBar)
- enter/insert text (asi keyDown)
- GSM (On/Off/SMS/...? silent mode...? vzdy od 18:00-19:00, ne:9:00-10:30?)
  PhnLibSetModulePower (refNum, Boolean);
  PhoneOn/Off
  BtOn/Off
  AlarmsOn/Off

Hotovo:
======
***********************/
// ====================================
// local function prototypes
// ------------------------------------
static Boolean BrightnessFormEventHandler (EventPtr eventP);
static Boolean OnPopupWinEnterEvent (FormPtr formP);
static Boolean OnPopupWinExitEvent (FormPtr formP);
static void SetKbdBL (Boolean state);
static UInt16 FindAlarm (UInt16 type, UInt32 *altime);
// ====================================
// DEBUG functions
// ------------------------------------
// DEBUG log to memopad
// ------------------------------------
#include <stdarg.h>
//void DEBUGm (char *a, ...)
//#define DEBUGm(a, ...) MemopadLog ("ML_DEBUG_log\n", a, __VA_ARGS__)
//#define DEBUGm(args...) MemopadLog ("ML_DEBUG_log\n", args)
#define DEBUGm(args...) MemopadLog ("ML_log\n", 'D', args)
// ------------------------------------
// generig log to memopad
// ------------------------------------
#define AlarmLog(args...) MemopadLog ("ML_log\n", 'L', args)
void MemopadLog (Char *record, UInt8 type, Char *fmt, ...) {
Char            *buf;
va_list         par;
DmOpenRef       db;
UInt16          num, rlen;
UInt32          len;
MemHandle       hndl;
UInt8           *ptr;
DateTimeType    dt;
  va_start(par, fmt);
  //db=DmOpenDatabaseByTypeCreator ('DATA', sysFileCMemo, dmModeReadWrite);
  db=DmOpenDatabaseByTypeCreator ('DATA', kPalmOneCreatorIDMemos, dmModeReadWrite);
  if (!db) return;
  // hledam zaznam, ktery zacina ML_log
  len=DmNumRecords (db);
  rlen=StrLen (record);
  for (num=0; num<len; num++) {
    hndl=DmQueryRecord (db, num);
    if (!hndl) continue;
    if (!StrNCompare (MemHandleLock (hndl), record, rlen)) {
      MemHandleUnlock (hndl);
      break;
    }
    MemHandleUnlock (hndl);
  }
  if (num>=len) {
    rlen++;
    hndl=DmNewRecord (db, &num, rlen);
    if (hndl) {
      DmWrite (MemHandleLock (hndl), 0, record, rlen);
      MemHandleUnlock (hndl);
      DmReleaseRecord (db, num, true);
    }
  }
  hndl=DmGetRecord (db, num);
  buf=MemPtrNew(256);
  if (hndl && buf) {
    rlen=0;
    if (type) {
      TimSecondsToDateTime (TimGetSeconds (), &dt);
      rlen=StrPrintF (buf, "[%c %d.%d.%d %02d:%02d:%02d]\n", type, dt.day, dt.month, dt.year, dt.hour, dt.minute, dt.second);
    }
    StrVPrintF (&buf[rlen], fmt, par);
    len=MemHandleSize (hndl);
    hndl=DmResizeRecord (db, num, len+StrLen (buf));
    //hndl=DmGetRecord (db, num);
    if (hndl) {
      ptr=MemHandleLock (hndl);
      DmWrite (ptr, StrLen (ptr), buf, StrLen (buf)+1);
      MemHandleUnlock (hndl);
      DmReleaseRecord (db, num, true);
    }
  }
  if (buf)
    MemPtrFree(buf);
  DmCloseDatabase (db);
  va_end(par);
}
// ====================================
// functions copied to FtrPtr memory
// ====================================
// resident notification handler for EventDequeued
// ------------------------------------
Err EventHandler (SysNotifyParamType *params) {
UInt32     bits;
EventType *eventP  = (EventType *)params->notifyDetailsP;
Int16      event   = EndianSwap16 ((Int16)eventP->eType);

  if (event == keyDownEvent) {
    Int16 vch = EndianSwap16 (((Int16)eventP->data.keyDown.chr));
    UInt16 mod = EndianSwap16 (eventP->data.keyDown.modifiers);
    UInt16 keycode = EndianSwap16 (eventP->data.keyDown.keyCode);
    UInt32 locked;
    FtrGet (AppID, FTR_BITS, &bits);
    // zpracovani tlacitek i v rezimu LOCKED
    // tisk uzitecnych informaci do okna keyguard
    if (vch==hsChrKeyboardLock) {
      // generating notification with keygueard window redraw request
      SysNotifyParamType srmNotify = { MLnotify, AppID, reqKeyguard, NULL, false, 0 };
      if ((bits & KEYGUARD_ON))
        SysNotifyBroadcastDeferred (&srmNotify, 0); //sizeof (srmNotifyDetails)+dw);
      return 0;
    }
    // test na rezim LOCKED
    HsAttrGet (hsAttrKeyboardLocked, 0, &locked);
    if (locked) return 0;
    // zpracovani ostatnich tlacitek
    // kontrola stavu GSI, kdyz je stisknuto 'p'
    if (vch=='p') {
      Boolean dummy1;
      UInt16 temp;
      HsGrfGetStateExt (&dummy1, &dummy1, &dummy1, &temp, &dummy1);
      if (temp!=hsGrfTempShiftOpt) return 0;
      vch=vchrBacklight;
      mod|=optionKeyMask;
    }
    // hsChrModifierKey
    if (vch == hsChrModifierKey) {
      // normal/night mode switch
      if (keycode==keyRightShift) {
        Boolean dummy1;
        UInt16 temp;
        if (!(bits & CONTRAST_KEYS)) return 0;
        HsGrfGetStateExt (&dummy1, &dummy1, &dummy1, &temp, &dummy1);
        if (temp!=hsGrfTempShiftOpt) return 0;
        // pokud je stisk, musim rucne vynulovat GSI
        HsGrfSetStateExt (false, false, false, false, false, false);
        vch=hsChrDarkMode;
        mod|=optionKeyMask;
      }
      // Menu -> CmdBar
      if (keycode==vchrMenu) {
        EventType nevt;
        if (!(bits & CMD_BAR_KEY) || !(mod&autoRepeatKeyMask)) return 0;
        if (mod & willSendUpKeyMask) {
          nevt.eType=menuCmdBarOpenEvent;
          nevt.data.menuCmdBarOpen.preventFieldButtons=false;
          EvtAddEventToQueue (&nevt);
        }
        return 0;
      }
      if (vch==hsChrModifierKey) return 0;
    }
    // test na klavesu pro zobrazeni dialogu na nastaveni podsviceni
    if (//vch == vchrPopupBrightness ||
        //vch == vchrBrightness || vch == vchrHardBrightness || 
        //((bits & OPTION_KEY) && vch == 'p') ||
        vch == vchrBacklight) {
      if (!(bits & CONTRAST_KEYS) || !(mod&optionKeyMask) || (mod & specialReleaseKeyMask)==specialReleaseKeyMask) return 0;
      if (!(bits & CONTRAST_REQUESTED)) {
        // generating notification with brightness dialog request
        SysNotifyParamType srmNotify = { MLnotify, AppID, reqBrightness, NULL, false, 0 };
        SysNotifyBroadcastDeferred (&srmNotify, 0); //sizeof (srmNotifyDetails)+dw);
      }
      // blocking standard PalmOS contrast dialog -> I think it isn't necessary because returning true...
      eventP->eType = EndianSwap16( nilEvent );
      // but if I don't change to nilEvent it behaves strange!!!
      params->handled=true;
      return 0;
    }
    // rizeni podsviceni LCD a klavesnice
    if (vch==hsChrDarkMode) {
      if (!(bits & CONTRAST_KEYS) || !(mod&optionKeyMask) || (mod & specialReleaseKeyMask)==specialReleaseKeyMask) return 0;
      // zjisteni aktualniho stavu
      HsLightMode (false, &mod);
      // nastaveni noveho stavu
      // zmena probiha takto: day w/o kbd, night w/ kbd, night w/o kbd
      if (mod==hsLightModeNormal) { // KBD on, NightMode
        while ((HsCurrentLightCircumstance() & hsLightCircumstanceKeylightOffFlagBit))
          HsLightCircumstance (false, hsLightCircumstanceKeylightOff);
        mod=hsLightModeNight;
        // je-li uroven 18, zvetsim ji na 19
        if (SysLCDBrightness (false, 0)==18) SysLCDBrightness (true, 19);
        HsLightMode (true, &mod);
      } else
      if (!(HsCurrentLightCircumstance() & hsLightCircumstanceKeylightOffFlagBit)) { // KBD off
        // je-li uroven 19, zmensim ji na 18
        if (SysLCDBrightness (false, 0)==19) SysLCDBrightness (true, 18);
        HsLightCircumstance (true, hsLightCircumstanceKeylightOff);
      } else { // KBD on, DayMode, KBD off
        while ((HsCurrentLightCircumstance() & hsLightCircumstanceKeylightOffFlagBit))
          HsLightCircumstance (false, hsLightCircumstanceKeylightOff);
        mod=hsLightModeNormal;
        HsLightMode (true, &mod);
        HsLightCircumstance (true, hsLightCircumstanceKeylightOff);
      }
      // blocking standard PalmOS contrast dialog -> I think it isn't necessary because returning true...
      eventP->eType = EndianSwap16( nilEvent );
      // but if I don't change to nilEvent it behaves strange!!!
      params->handled=true;
      return 0;
    }
    // rizeni posunu kurzoru a oznacovani bloku textu
    if (vch==vchrRockerLeft || vch==vchrRockerRight
#ifdef UP_DOWN_SELECT
        || vch==vchrPageUp || vch==vchrPageDown
#endif
        ) {
      Boolean dummy1, caps;
      UInt16 temp;
      // promenne pro oznacovani
      FieldPtr fld;
      Char *txtPtr;
      UInt16 txtLen, selStart, selEnd, txtEdge, insPos;
      if (!(bits & SELECTION_KEYS)) return 0;
      // uvolneni klavesy
      if ((mod & specialReleaseKeyMask) == specialReleaseKeyMask) return 0;
      // zjistim stav GSI
      HsGrfGetStateExt (&caps, &dummy1, &dummy1, &temp, &dummy1);
      if (caps) mod|=shiftKeyMask;
      // pokud se jedna o standardni rezim posunu, tak necham provadet system!
      // jen znakovy posunovaci rezim?
      if (!(mod&(shiftKeyMask|autoRepeatKeyMask))) return 0;
      // zjistim, zda je field aktivni
      if ((fld=FrmGetActiveField (NULL)) == NULL) return 0;
      if ((txtPtr=FldGetTextPtr (fld)) == NULL) return 0;
      // nactu parametry textu ve FIELDu
      txtLen = FldGetTextLength (fld);
      FldGetSelection (fld, &selStart, &selEnd);
      insPos = FldGetInsPtPosition (fld);
      txtEdge = (insPos==selStart) ? selEnd :selStart;
#ifdef UP_DOWN_SELECT
      if (vch==vchrRockerLeft || vch==vchrRockerRight) {
#endif
        // je-li autoRepeatKeyMask, tak posunuju/skacu po slovech
        if (mod&autoRepeatKeyMask) { 
          // WORD mode
          Char *str=txtPtr;
          Int16 i=insPos;
          Int16 inc=(vch==vchrRockerLeft)?-1:1;
          // hledani hranice slova
          while ((i+inc)>=0 && (i+inc)<=txtLen) {
            i+=inc;
            if (i<=0 || i>=txtLen) break;
            if (TxtCharIsAlNum (str[i]) && !TxtCharIsAlNum (str[i-1]))
              break;
          }
          //if (i<0 || i>txtLen) return 0;
          // priprava promennych
          if (mod&shiftKeyMask) {
            insPos=i;
          } else {
            insPos=txtEdge=i;
          }
        } else {
          // CHAR mode
          if (vch==vchrRockerLeft) if (insPos) insPos--;
          if (vch==vchrRockerRight) if (insPos<txtLen) insPos++;
        }
#ifdef UP_DOWN_SELECT
      } else {
        UInt16 begln, visln, totln, i, start, length;
        LineInfoPtr fldline=fld->lines;
        if (!(mod&shiftKeyMask)) return 0;
        //if (!(mod&shiftKeyMask) || !fldline) return 0;
        // podle pozice si zjistim, na kterem radku je insPt
        FldGetScrollValues (fld, &begln, &totln, &visln);
        if (totln<visln) visln=totln;
        for (i=0; i<visln; i++) {
        //for (i=0; i<totln; i++) {
          //if (FldGlueGetLineInfo (fld, i, &start, &length))
          start=fldline[i].start; length=fldline[i].length;
            //if (insPos<start || insPos<start+length) break;
            if (insPos>=start && insPos<start+length) break;
        }
        if (vch==vchrPageUp) {
          if (i) {
            i--;
            //if (FldGlueGetLineInfo (fld, i, &begln, &totln))
            begln=fldline[i].start; totln=fldline[i].length;
              insPos=(insPos-start)>=totln?begln+totln-1:begln+insPos-start;
          } else
          if (begln) {
            FldScrollField (fld, 1, winUp);
            //if (FldGlueGetLineInfo (fld, i, &begln, &totln))
            begln=fldline[i].start; totln=fldline[i].length;
              insPos=(insPos-start)>=totln?begln+totln-1:begln+insPos-start;
          } else
          //if (insPos) {
            insPos=0;
          //}
        } else {
          if (i+1<visln) {
            i++;
            //if (FldGlueGetLineInfo (fld, i, &begln, &totln))
            begln=fldline[i].start; totln=fldline[i].length;
              insPos=(insPos-start)>=totln?begln+totln-1:begln+insPos-start;
          } else
          if (begln+visln<totln) {
            FldScrollField (fld, 1, winDown);
            //if (FldGlueGetLineInfo (fld, i, &begln, &totln))
            begln=fldline[i].start; totln=fldline[i].length;
              insPos=(insPos-start)>=totln?begln+totln-1:begln+insPos-start;
          } else
          //if (insPos<txtLen) {
            insPos=txtLen;
          //}
        }
        //return 0;
      }
#endif
      //SetSelection ();
      FldSetInsPtPosition (fld, insPos);
      if (insPos>txtEdge) {
        FldSetSelection (fld, txtEdge, insPos);
      } else {
        FldSetSelection (fld, insPos, txtEdge);
      }
      // blocking standard PalmOS contrast dialog -> I think it isn't necessary because returning true...
      eventP->eType = EndianSwap16( nilEvent );
      // but if I don't change to nilEvent it behaves strange!!!
      params->handled=true;
      return 0;
    }
  }
  return 0;
}
/**
// ====================================
// text selection functions
// ====================================
// ------------------------------------
void    SetSelection    ( THackGlobals* pVars ) {
FldSetInsPtPosition( pVars->pCurField, pVars->iFieldInsPos );

if ( pVars->iFieldInsPos > pVars->wEdge )
  FldSetSelection( pVars->pCurField, pVars->wEdge, pVars->iFieldInsPos );
else
  FldSetSelection( pVars->pCurField, pVars->iFieldInsPos, pVars->wEdge );
}
void    SetCursor       ( THackGlobals* pVars, int iPos ) {
pVars->iFieldInsPos = pVars->wEdge = iPos;
SetSelection( pVars );
}
Boolean         InFld           ( THackGlobals* pVars, int iPos ) {
return iPos >= 0 && iPos <= pVars->iFieldTextLen;
}
void    ShiftsUp        ( THackGlobals* pVars ) {
pVars->dwFlags &= ~( HFLG_SHIFT | HFLG_CTRL | HFLG_ALT );
FtrSet( HACKID, FTR_FLAGS, pVars->dwFlags );
}
int FindWord (THackGlobals* pVars, int iInc) {
CharPtr pszText = pVars->pszText;
//WordPtr pCharAttr = (WordPtr)GetCharAttr();
int     i = pVars->iFieldInsPos;

while ( ( i += iInc ) >= 1 && i < pVars->iFieldTextLen )
//  if ( IsAlNum( pCharAttr, pszText[i] ) && !IsAlNum( pCharAttr, pszText[i - 1] ) )
  if ( TxtCharIsAlNum( pszText[i] ) && !TxtCharIsAlNum( pszText[i - 1] ) )
    break;

if ( InFld( pVars, i ) )
  return i;

return -1;
}
int FindLine (THackGlobals* pVars, Boolean fBegin) {
Word            w1, w2, w3;
int             i;

if ( NULL == ( pVars->pCurField->lines ) )
  return fBegin ? 0 : pVars->iFieldTextLen;

FldGetScrollValues( pVars->pCurField, &w1, &w2, &w3 );

for ( i = 0 ; i < w2 ; i++ )
  {
  LineInfoPtr   p = pVars->pCurField->lines + i;
  Word          wTemp;

  if ( ( wTemp = ( p->length + ( i == w2 - 1 ) ) + p->start - 1 ) >= pVars->iFieldInsPos )
    {
    if ( fBegin )
      return p->start;
    else
      if ( wTemp > pVars->iFieldTextLen )
	return pVars->iFieldTextLen;
      else
	return wTemp;
    }
  }

return -1;
}


	    case CMD_HOME:
	    case CMD_END:
	      if ( GetCurField( pVars ) )
		SetCursor( pVars, CMD_HOME == w ? 0 : pVars->iFieldTextLen );
	      break;

	    case CMD_LINEHOME:
	    case CMD_LINEEND:
	      if ( GetCurField( pVars ) )
		{
		int     iPos;

		if ( -1 != ( iPos = FindLine( pVars, CMD_LINEHOME == w ) ) )
		  SetCursor( pVars, iPos );
		}
	      break;

	    case CMD_SELLINEHOME:
	    case CMD_SELLINEEND:
	      if ( GetCurField( pVars ) )
		{
		int     iPos;

		if ( -1 != ( iPos = FindLine( pVars, CMD_SELLINEHOME == w ) ) )
		  {
		  pVars->iFieldInsPos = iPos;
		  SetSelection( pVars );
		  }
		}
	      break;

	    case CMD_SELHOME:
	    case CMD_SELEND:
	      if ( GetCurField( pVars ) )
		{
		pVars->iFieldInsPos = CMD_SELHOME == w ? 0 : pVars->iFieldTextLen;
		SetSelection( pVars );
		}
	      break;

	    case CMD_SELRIGHT:
	    case CMD_SELLEFT:
	      if ( GetCurField( pVars ) )
		{
		int     iInc = CMD_SELLEFT == w ? -1 : 1;

		if ( InFld( pVars, pVars->iFieldInsPos + iInc ) )
		  {
		  pVars->iFieldInsPos += iInc;
		  SetSelection( pVars );
		  }
		}
	      break;

	    case CMD_SELRIGHTWORD:
	    case CMD_SELLEFTWORD:
	      if ( GetCurField( pVars ) )
		{
		int     iPos;

		if ( -1 != ( iPos = FindWord( pVars, CMD_SELLEFTWORD == w ? -1 : 1 ) ) )
		  {
		  pVars->iFieldInsPos = iPos;
		  SetSelection( pVars );
		  }
		}
	      break;

	    case CMD_PREVWORD:
	    case CMD_NEXTWORD:
	      if ( GetCurField( pVars ) )
		{
		int     iPos;

		if ( -1 != ( iPos = FindWord( pVars, CMD_PREVWORD == w ? -1 : 1 ) ) )
		  SetCursor( pVars, iPos );
		}
	      break;

**/
// ====================================
// end of copied block to FtrPtr memory
// ====================================
Err NotifyProc (SysNotifyParamType *params) {
UInt16          i;
UInt32          bits;
Char            name[32];
DmOpenRef       recdb;
MemHandle       rechndl;
alarmType       ainfo, *aptr;
UInt32          lastoff, time;

  FtrGet (AppID, FTR_BITS, &bits);
/**
  // the fastest notification handling! - but as it must look for feature it will slow the Palm down quite a bit
  if (params->notifyType==sysNotifyEventDequeuedEvent && (bits & (CONTRAST_KEYS | SELECTION_KEYS | CMD_BAR_KEY))) {
    return EventHandler (params);
  } else
**/
  // ------ basic notification (can't be disabled)
  if (params->notifyType==sysNotifyAppLaunchingEvent) {
    // pri pusteni aplikace ulozim locid spoustene aplikace
    if (bits & SCHEDULER_ON) {
      FtrSet (AppID, FTR_APP, ((SysNotifyAppLaunchOrQuitType*)params->notifyDetailsP)->dbID);
    }
    // retrieve app's name
    if (DmDatabaseInfo (((SysNotifyAppLaunchOrQuitType*)(params->notifyDetailsP))->cardNo, ((SysNotifyAppLaunchOrQuitType*)(params->notifyDetailsP))->dbID,
                        name, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL)!=errNone) return 0;
    // open recent database
    recdb=DmOpenDatabaseByTypeCreator (RecentType, AppID, dmModeReadWrite);
    if (!recdb) return 0;
    // look for this name in saved apps
    for (i=0; i<DmNumRecords (recdb); i++) {
      rechndl=DmQueryRecord (recdb, i);
      if (rechndl==NULL) continue;
      if (!StrCompare (name, MemHandleLock (rechndl))) {
        // launched app is in database already
        MemHandleUnlock (rechndl);
        if (i)
          // move it to be the first in list...
          DmMoveRecord (recdb, i, 0);
        DmCloseDatabase (recdb);
        return 0;
      }
      MemHandleUnlock (rechndl);
    }
    // app isn't in list
    // if the list is full, release last item
    while (DmNumRecords (recdb)>MaxRecent+1) {
      DmRemoveRecord (recdb, DmNumRecords (recdb)-1);
    }
    // save current app's name to the first position
    i=0;
    rechndl=DmNewRecord (recdb, &i, StrLen (name)+1);
    if (rechndl!=NULL) {
      DmWrite (MemHandleLock (rechndl), 0, name, StrLen (name)+1);
      MemHandleUnlock (rechndl);
      DmReleaseRecord (recdb, i, true);
    }
    DmCloseDatabase (recdb);
    return 0;
  } else
/********************************
  // ------ graffiti notification for T|E patching and graffiti control
  if (params->notifyType==sysNotifyProcessPenStrokeEvent) {
    if ((bits & (GRAFFITI_PATCH | GRAFFITI_CONTROL)) {
      #define PenQlen 256
      SysNotifyPenStrokeType *penP=params->notifyDetailsP;
      PointType pq[PenQlen], pcal;
      UInt16 cnt;
      i=0;
      // oprava chyby graffiti: pokud tah zacina a konci na tlacitku (D, B), tak se misto napsani pismene spusti klavesnice
      if (penP->startPt.x>=27 && penP->startPt.x<=44 && penP->startPt.y>=206 && penP->startPt.y<=219 &&
          penP->endPt.x>=27 && penP->endPt.x<=44 && penP->endPt.y>=206 && penP->endPt.y<=219 && (bits & GRAFFITI_PATCH)) {
        // odstranim cely penstroke
        //EvtDequeuePenStrokeInfo (&pnt1, &pnt2);
        // tuto funkci asi vola notifikacni proces...
        // z fronty odstranim cely tah a nahradim ho novym
        MemMove (&pq[0], &penP->startPt, sizeof (PointType));
        cnt=1;
        while (1) {
          EvtDequeuePenPoint (&pq[cnt]);
          if (pq[cnt].x==-1 && pq[cnt].y==-1) {
            MemMove (&pq[cnt+1], &pq[cnt], sizeof (PointType));
            MemMove (&pq[cnt], &penP->endPt, sizeof (PointType));
            cnt++;
            break;
          }
          if (pq[cnt].x==pq[cnt-1].x && pq[cnt].y==pq[cnt-1].y)
            continue;
          if (cnt<PenQlen-1) cnt++;
        }
        // smazu celou frontu
        EvtFlushPenQueue ();
        // zacnu vkladat novy tah
        // nejprve preskocim vsechny, ktere jsou v tlacitkove oblasti
        for (i=0; i<cnt; i++)
          if (pq[i].x<27 || pq[i].x>44 || pq[i].y<206 || pq[i].y>219)
            break;
        if (i>=cnt) {
          EventType event;
          // nemuzu totiz zapsat toto zpet do fronty, protoze bych se zacyklil!!!
          // leda ze bych si zapamatoval, ze dalsi tah nemam zpracovat
          // to by vsak znamenalo pouzit features, coz by dale zdrzovalo...

          // spustim SW klavesnici
          //SysKeyboardDialog (kbdDefault);
          // musim vygenerovat keyDown, protoze SysKeyboardDialog se dokaze spustit vickrat pres sebe... :-(
          MemSet (&event, sizeof (EventType), 0);
          event.eType=keyDownEvent;
          event.data.keyDown.chr=vchrKeyboardAlpha;
          event.data.keyDown.modifiers=commandKeyMask;
          EvtAddEventToQueue (&event);
          params->handled=true;
          return 0;
        }
        // vypocitam kalibraci
        pcal.x=pcal.y=120;
        PenScreenToRaw (&pcal);
        PenRawToScreen (&pcal);
        pcal.x=120-pcal.x;
        pcal.y=120-pcal.y;
        //if (i>=cnt) i=cnt-1;
        // ted zapisu cely tah, ale posunu ho mimo tlacitko doprava
        for (i=0; i<cnt; i++) {
          pq[i].x+=45-penP->startPt.x;
          pq[i].x*=2; pq[i].y*=2;
          pq[i].x+=pcal.x; pq[i].y+=pcal.y;
          PenScreenToRaw (&pq[i]);
          EvtEnqueuePenPoint (&pq[i]);
        }
        EvtEnqueuePenPoint (&pq[cnt]);
        params->handled=true;
        return 0;
      }
      // zpracovani tahu z 'LAUNCH' na 'MENU' -> spusteni predchozi aplikace
      if (penP->startPt.x>=0 && penP->startPt.x<=26 && penP->startPt.y>=164 && penP->startPt.y<=191 &&
          penP->endPt.x>=0 && penP->endPt.x<=26 && penP->endPt.y>=192 && penP->endPt.y<=219 && (bits & GRAFFITI_CONTROL)) {
        recdb=DmOpenDatabaseByTypeCreator (RecentType, AppID, dmModeReadWrite);
        if (!recdb) return 0;
        rechndl=DmQueryRecord (recdb, 1);
        if (rechndl!=NULL) {
          if (!StrCompare (str=MemHandleLock (rechndl), "MLaunch")) {
            MemHandleUnlock (rechndl);
            rechndl=DmQueryRecord (recdb, 2);
            if (rechndl!=NULL) str=MemHandleLock (rechndl);
          }
        }
        if (rechndl!=NULL) {
          SysCurAppDatabase (&card, &dbid);
          dbid=DmFindDatabase (card, str);
          if (dbid)
            SysUIAppSwitch (card, dbid, sysAppLaunchCmdNormalLaunch, NULL);
          MemHandleUnlock (rechndl);
        }
        DmCloseDatabase (recdb);
        i=0;
      }
      // zpracovani tahu z 'MENU' na 'LAUNCH' -> zobrazeni seznamu predchozich aplikaci
      if (penP->startPt.x>=0 && penP->startPt.x<=26 && penP->startPt.y>=192 && penP->startPt.y<=219 &&
          penP->endPt.x>=0 && penP->endPt.x<=26 && penP->endPt.y>=164 && penP->endPt.y<=191 && (bits & GRAFFITI_CONTROL)) {
        i=ShowRecentList;
      }
      if (i) {
        params->handled=true;
        SysCurAppDatabase (&card, &dbid);
        dbid=DmFindDatabase (card, "MLaunch");
        if (dbid)
          SysUIAppSwitch (card, dbid, i, NULL);
        return 0;
      }
      return 0;
    }
  } else
********************************/
  // ------ Backlight popup dialog notification (broadcast from EventDequeued handler)
  if (params->notifyType==MLnotify) {
    FormPtr activeFormP = FrmGetActiveForm();
    FormPtr popupFormP;
    if (params->notifyDetailsP==reqBrightness) {
      // preparing contrast dialog
      FtrSet (AppID, FTR_BITS, bits | CONTRAST_REQUESTED);
      popupFormP = FrmInitForm (contrast_popup);
      FrmSetEventHandler (popupFormP, BrightnessFormEventHandler);
      // displaying dialog
      FrmDoDialog (popupFormP);
      // delete form data
      OnPopupWinExitEvent (popupFormP);
      // delete form
      FrmDeleteForm (popupFormP);
      // restoring flags
      FtrGet (AppID, FTR_BITS, &bits);
      FtrSet (AppID, FTR_BITS, bits & ~CONTRAST_REQUESTED);
      FrmSetActiveForm (activeFormP);
    } else
    if (params->notifyDetailsP==reqKeyguard) {
      Char txt[32];
      DateTimeType dt;
      Boolean charge;
      UInt8 percent;
      RectangleType rec;
      FontID prevfont;
      Coord width, height;
      
      WinGetWindowExtent (&width, &height);
      // DEBUGm ("guard size: %dx%d", width, height);
      // okno je velikosti 156x30
      if (width==156 || height==30) {
        // preparing keyguard texts
        TimSecondsToDateTime (TimGetSeconds (), &dt);
        SysBatteryInfo (false, NULL, NULL, NULL, NULL, &charge, &percent);
        percent=StrPrintF (txt, "%02d:%02d  %d.%d.%d  %d%%%c", dt.hour, dt.minute, dt.day, dt.month, dt.year, percent, charge?'!':' ');

        // erasing window
        //rec.topLeft.x=21; rec.topLeft.y=4; rec.extent.x=133; rec.extent.y=20; // minimalni rozmer
        rec.topLeft.x=21; rec.topLeft.y=4; rec.extent.x=135; rec.extent.y=25; // snad tak akorat...
        //rec.topLeft.x=21; rec.topLeft.y=4; rec.extent.x=153; rec.extent.y=30; // maximalni rozmer
        WinEraseRectangle (&rec, 0);

        // redrawing window
        prevfont=FntSetFont (boldFont);
        WinDrawChars (txt, percent, 21, 4);
        WinDrawChars ("Press Center button", 19, 21, 15);
        FntSetFont (prevfont);
      }
    }
    return 0;
  } else
  // ------ SleepNotifyEvent - PowerOFF
  if (params->notifyType==sysNotifySleepNotifyEvent) {
    // switch off keyboard backlight
    SetKbdBL (false);
    if (bits & SCHEDULER_ON) {
      // pokud bylo zapnuto uzivatelem, ulozim novy cas
      lastoff=-1;
      FtrGet (AppID, FTR_KEYS, &lastoff);
      time=TimGetSeconds ();
      //DEBUGm ("Keys OFF: %08lX\n", KeyCurrentState ());
      // jak se da poznat, ze doslo k vypnuti tlacitkem???
      // vypada to, ze vypnuti se generuje az pri pusteni klavesy, takze zadne uz nezjistim...
      //if (lastoff || KeyCurrentState ()) {
      if (lastoff) {
        // pokud doslo k zapnuti nebo vypnuti uzivatelem, ukladam aktualni cas
        FtrSet (AppID, FTR_OFF, time);
        // dobu od posledniho vypnuti nastavim na 0
        lastoff=0;
      } else {
        // vypocitam dobu od posledniho vypnuti uzivatelem
        if (!FtrGet (AppID, FTR_OFF, &lastoff))
          lastoff=time-lastoff;
        else
          lastoff=0;
      }
      // zkontroluju dalsi alarmy (pro TASK_OFF plati minimalni cas v lastoff)
      if (bits & DEBUGLOG_ON)
        DEBUGm ("Sleep\n");
      SetTaskAlarm (lastoff, FindAlarm (TASK_after, &lastoff));
    }
    return 0;
  } else
  // ------ EarlyWakeupEvent - switch ON
  if (params->notifyType==sysNotifyEarlyWakeupEvent) {
    if (bits & SCHEDULER_ON) {
      // pri rannem probuzeni (zapnuti) ulozim stav hardKeys
      FtrSet (AppID, FTR_KEYS, KeyCurrentState ());
    }
    return 0;
  } else
  // ------ LateWakeupEvent - switch ON
  if (params->notifyType==sysNotifyLateWakeupEvent) {
    if (bits & SCHEDULER_ON) {
      // pripravim masku tlacitka power
      FtrGet (sysFtrCreator, sysFtrNumOEMDeviceID, &time);
      time=(time==kPalmOneDeviceIDTreo650)?keyBitHard4:keyBitPower;
      // nactu zpusob zapnuti Palmu
      FtrGet (AppID, FTR_KEYS, &lastoff);
      // pokud nebylo zapnuto tlacitkem Power, nebudu planovat NIC (protoze se jedna bud o alarm nebo o SMS apod)...
      // musim totiz nechat probehnout pripadny alarm a teprve pak muzu neco planovat...
      // jedine co 'hrozi' je ze se spusti neco po urcite dobe necinnosti, ale to je vlastne funkce... :-)
      if (!(lastoff & time))
        return 0;
      // najdu nebo smazu alarm...
      time=lastoff=TimGetSeconds ();
      FtrGet (AppID, FTR_OFF, &lastoff);
      lastoff=time-lastoff;
      if (!FtrGet (AppID, FTR_ALARM, (UInt32*)&aptr)) {
        MemMove (&ainfo, aptr, sizeof (ainfo));
        // pokud je rozpracovany ukol, uzavru ho
        if (ainfo.tptr) {
          MemPtrUnlock (ainfo.tptr);
          ainfo.tptr=0;
        }
      } else {
        MemSet (&ainfo, sizeof (ainfo), 0);
        aptr=0;
      }
      // najit alarm po zapnuti
      if (bits & DEBUGLOG_ON)
        DEBUGm ("WakeUp alarm\n");
      ainfo.tasknum=FindAlarm (TASK_on, &lastoff);
      if (ainfo.tasknum!=0xFFFF) {
        // spusti ulohu po zapnuti
        if (aptr)
          DmWrite (aptr, 0, &ainfo, sizeof (ainfo));
        FtrSet (AppID, FTR_STEP, 0);
        ExecAlarm ();
      } else {
        // nastavi alarm na cas nebo smaze alarm...
        if (bits & DEBUGLOG_ON)
          DEBUGm ("WakeUp time alarm\n");
        SetTaskAlarm (lastoff, FindAlarm (TASK_time, &lastoff));
      }
    }
    return 0;
/**********
  } else
  if (params->notifyType==hsNotifyRemSleepRequestEvent) {
    // podpora pro REM sleep
    ((SleepEventParamType*)(params->notifyDetailsP))->deferSleep++;
    return 0;
**********/
  }
  return 0;
}
// ====================================
// main enable/disable function
// ------------------------------------
#define PenPriority     96
Err EnableMLauncher (UInt32 bits) {
//UInt16          card;
//LocalID         dbid;
void            *proc;
alarmType       ainfo, *aptr;
UInt32          time;

  time=(bits & MULTILAUNCHER_ON)?AppID:sysFileCLauncher;
  if (PrefGetPreference (prefLauncherAppCreator)!=time)
    PrefSetPreference (prefLauncherAppCreator, time);
  FtrSet (AppID, FTR_BITS, bits);
  MemSet (&ainfo, sizeof (ainfo), 0);
  SysCurAppDatabase (&ainfo.card, &ainfo.locid);
  if (!(bits & MULTILAUNCHER_ON)) bits=0;
  // nejprve se zrusi vsechny notifikace
  while (!SysNotifyUnregister (ainfo.card, ainfo.locid, sysNotifyAppLaunchingEvent, sysNotifyNormalPriority));
  //SysNotifyUnregister (ainfo.card, ainfo.locid, sysNotifyAppQuittingEvent, sysNotifyNormalPriority); // not needed...
  while (!SysNotifyUnregister (ainfo.card, ainfo.locid, sysNotifyEarlyWakeupEvent, sysNotifyNormalPriority));
  while (!SysNotifyUnregister (ainfo.card, ainfo.locid, sysNotifyLateWakeupEvent, sysNotifyNormalPriority));
  while (!SysNotifyUnregister (ainfo.card, ainfo.locid, sysNotifySleepNotifyEvent, sysNotifyNormalPriority));
  while (!SysNotifyUnregister (ainfo.card, ainfo.locid, sysNotifyProcessPenStrokeEvent, PenPriority));
  while (!SysNotifyUnregister (ainfo.card, ainfo.locid, sysNotifyEventDequeuedEvent, sysNotifyNormalPriority));
  while (!SysNotifyUnregister (ainfo.card, ainfo.locid, MLnotify, sysNotifyNormalPriority));
  // smazu pamet pro event handler
  if (!FtrGet (AppID, FTR_HANDLER_PROC, (UInt32*)&proc))
    FtrPtrFree (AppID, FTR_HANDLER_PROC);
  // zrusim alarm
  AlmSetAlarm (ainfo.card, ainfo.locid, 0, 0, 0);
  // ted se spusti jen ty, ktere jsou potreba
  if (bits & (MULTILAUNCHER_ON | SCHEDULER_ON)) {
    SysNotifyRegister (ainfo.card, ainfo.locid, sysNotifyAppLaunchingEvent, NULL, sysNotifyNormalPriority, NULL);
    //SysNotifyRegister (ainfo.card, ainfo.locid, sysNotifyAppQuittingEvent, &NotifyProc, sysNotifyNormalPriority, NULL); // not needed...
  }
  if (bits & SCHEDULER_ON) {
    SysNotifyRegister (ainfo.card, ainfo.locid, sysNotifyEarlyWakeupEvent, &NotifyProc, sysNotifyNormalPriority, NULL);
    SysNotifyRegister (ainfo.card, ainfo.locid, sysNotifyLateWakeupEvent, &NotifyProc, sysNotifyNormalPriority, NULL);
    // vytvoreni zaznamu FTR_ALARM
    if (FtrGet (AppID, FTR_ALARM, (UInt32*)&aptr))
      if (FtrPtrNew (AppID, FTR_ALARM, sizeof (ainfo), (void**)&aptr))
        aptr=0;
    ainfo.tasknum=-1;
    if (aptr)
      DmWrite (aptr, 0, &ainfo, sizeof (ainfo));
    // naplanuju odpovidajici alarm
    time=TimGetSeconds ();
    // vypada to, ze FindAlarm shodi Palm pri resetu!
    // takze nez prijdu na to, cim to je, musim tento kod zakazat...
    FindAlarm (TASK_time, &time);
    SetTaskAlarm (time, FindAlarm (TASK_time, &time));
  }
  if (bits & (CONTRAST_KEYS | SCHEDULER_ON)) {
    SysNotifyRegister (ainfo.card, ainfo.locid, sysNotifySleepNotifyEvent, &NotifyProc, sysNotifyNormalPriority, NULL);
  }
  if (bits & (GRAFFITI_PATCH | GRAFFITI_CONTROL))
    SysNotifyRegister (ainfo.card, ainfo.locid, sysNotifyProcessPenStrokeEvent, NULL, PenPriority, NULL);
  if (bits & (CONTRAST_KEYS | SELECTION_KEYS | CMD_BAR_KEY)) {
    UInt32 size=(((UInt8*)&NotifyProc)+0x10)-(((UInt8*)&EventHandler)+0x10);
    FtrPtrNew (AppID, FTR_HANDLER_PROC, size, &proc);
    //DEBUG ("Mem 0x%08lX bytes at %08lX", size, proc);
    //DEBUG ("Func @ 0x%lX: 0x%lX bytes", (UInt32)&EventHandler, (UInt32)sizeof (EventHandler)); // tento zpusob urceni delky funkce nefunguje :-(
    DmWrite (proc, 0, &EventHandler, size);
    SysNotifyRegister (ainfo.card, ainfo.locid, sysNotifyEventDequeuedEvent, proc, sysNotifyNormalPriority, NULL);
  }
  if (bits)
    SysNotifyRegister (ainfo.card, ainfo.locid, MLnotify, NULL, sysNotifyNormalPriority, NULL);
  return 0;
}
// ====================================
// Ir gadget functions
// ------------------------------------
// discovering Ir state
// ------------------------------------
Int16 GetIrState (void) {
UInt16          size;
Boolean         state;
UInt16          IrLibRef;

  if (SysLibFind (irLibName, &IrLibRef)) return -1;
  size=sizeof (state);
  ExgLibControl (IrLibRef, irGetScanningMode, &state, &size);
  return (state)?1:0;
}
// ------------------------------------
// setting Ir state
// ------------------------------------
void SetIrState (UInt16 state) {
Boolean  irda;
UInt16   IrLibRef;
UInt16   size;
  if (!SysLibFind (irLibName, &IrLibRef)) {
    size=sizeof (irda);
    irda=state;
    ExgLibControl (IrLibRef, irSetScanningMode, &irda, &size);
  }
}
// ------------------------------------
// discovering/setting Alarm state
// ------------------------------------
Int16 AlmState (Int16 state) {
Int32           ftrval;
UInt16          TLibRef, cnt, chng;
SoundPreference spref;
SoundPrefBackupType SndBack[soundPrefTypeLast];
Int16           i;

  // nacteni ulozeneho nastaveni
  cnt=0;
  MemSet (&SndBack, sizeof (SndBack), 0);
  i=PrefGetAppPreferences (AppID, PREF_SND, NULL, &cnt, true);
  if (i!=noPreferenceFound) {
    if (cnt > sizeof (SndBack)) cnt=sizeof (SndBack);
    PrefGetAppPreferences (AppID, PREF_SND, &SndBack, &cnt, true);
  }
  // zjisteni stavu prepinace
  if (HsAttrGet (hsAttrRingSwitch, 0, &ftrval)) {
    if (state<0) return -1;
  } else {
    if (ftrval==hsAttrRingSwitchMute && state<0) return 0;
  }
  if (SysLibFind (tonesLibName, &TLibRef)) return -2;
  //if (err)
  //  err = SysLibLoad (tonesLibType, tonesLibCreator, &TonesLibRefNum);
  chng=0;
  ftrval=(ftrval==hsAttrRingSwitchMute)?(-10-soundPrefTypeLast):0;
  for (cnt=soundPrefTypePhone; cnt<soundPrefTypeLast; cnt++) {
    if (TonesLibGetSoundPrefs (TLibRef, cnt, &spref)) continue;
    // pokud je hlasitost a je jina nez ulozena, ulozim ji
    if (spref.soundOnVolume!=toneVolumeOff) {
      ftrval++; // toto vrati pri nastavovani predchozi hodnotu!!!
      if (spref.soundOnVolume!=SndBack[cnt].soundOnVolume) {
        SndBack[cnt].soundOnVolume=spref.soundOnVolume;
        SndBack[cnt].soundOnVibrate=spref.soundOnVibrate;
        chng|=0x01;
      }
    }
    if (state<0) continue;
    chng&=~0x02;
    if (state) {
      if (spref.soundOnVolume!=SndBack[cnt].soundOnVolume) {
        spref.soundOnVolume=SndBack[cnt].soundOnVolume;
        spref.soundOnVibrate=SndBack[cnt].soundOnVibrate;
        chng|=0x02;
      }
    } else {
      if (spref.soundOnVolume!=toneVolumeOff) {
        spref.soundOnVolume=toneVolumeOff;
        spref.soundOnVibrate=spref.soundOffVibrate;
        chng|=0x02;
      }
    }
    // nastaveni noveho stavu - jen kdyz se lisi!!!
    if (chng&0x02)
      TonesLibSetSoundPrefs (TLibRef, cnt, &spref);
  }
  if (chng&0x01) {
    PrefSetAppPreferences (AppID, PREF_SND, 0, &SndBack, sizeof (SndBack), true);
  }
  return (ftrval>0);
}
// ====================================
// discovering/setting Phone state
// ------------------------------------
Int16 PhoneState (Int16 state) {
UInt16 ref, prev;
  // zmena stavu telefonu
  if (HsGetPhoneLibrary (&ref)) return -1;
  prev=(PhnLibModulePowered (ref)==phnPowerOn);
  if (state<0) return prev;
  if (state!=prev)
    PhnLibSetModulePower (ref, state);
  return state;
}
// ====================================
// discovering/setting BlueTooth state
// ------------------------------------
static Int16 BTstate (Int16 state) {
  return -1;
}
// ====================================
// keyboard backlight function
// ------------------------------------
static void SetKbdBL (Boolean state) {
  if (state) {
    // turn on if requested - it can be off multiple times
    while ( (HsCurrentLightCircumstance() & hsLightCircumstanceKeylightOffFlagBit))
      HsLightCircumstance (false, hsLightCircumstanceKeylightOff);
  } else {
    // turn off if requested - on state is one times only
    if (!(HsCurrentLightCircumstance() & hsLightCircumstanceKeylightOffFlagBit))
      HsLightCircumstance (true, hsLightCircumstanceKeylightOff);
  }
}
// ------------------------------------
// dummy functions
// ------------------------------------
//#define PhoneState(a) DEBUGm("Phone: %ld", a)
//#define BTstate(a) DEBUGm("BT: %ld", a)
//#define AlmState(a) DEBUGm("Sounds: %ld", a)
// ------------------------------------
// enqueing pen point
// ------------------------------------
static void AddPenPoint (Int16 x, Int16 y) {
PointType       point;
  point.x=x;
  point.y=y;
  if (x>0 && y>0)
    PenScreenToRaw (&point);
  EvtEnqueuePenPoint (&point);
}
// ------------------------------------
// provadeni kroku
// ------------------------------------
static Int16 ExecStep (stepType *sptr) {
UInt16          card;
LocalID         locid, runid;
EventType       evt;
UInt32          keys;
/**
Int16           i;
MemHandle       hndl;
DmOpenRef       db;
**/
  switch (sptr->action) {
    case STEP_launch:
      card=0;
      locid=DmFindDatabase (card, sptr->data.str);
      if (!locid) return -1;
      // nactu naposledy spustenou aplikaci a porovnam
      FtrGet (AppID, FTR_APP, &runid);
      // podivam se do recordu 0 v databazi
/**
      i=1;
      if ((db=DmOpenDatabaseByTypeCreator (RecentType, AppID, dmModeReadWrite))) {
        hndl=DmQueryRecord (db, 0);
        if (hndl) {
          i=StrCompare (sptr->data.str, MemHandleLock (hndl));
          MemHandleUnlock (hndl);
        }
        DmCloseDatabase (db);
      }
      DEBUG ("Run: %d", i);
      if (i)
**/
      if (locid!=runid)
        SysUIAppSwitch (card, locid, sysAppLaunchCmdNormalLaunch, NULL);
      break;
    case STEP_event:
      // pendown/penup asi budu muset prevadet na EvtEnqueuePenPoint...
      // u HiRes je nutne prepocitat na HiRes...
      // souradnice se prevedou na fyzicke (nekalibrovane) pomoci PenScreenToRaw
      // nebo udelat dalsi akci: pen tap (umozni zadat az 8 bodu tahu)
      card=sptr->data.event.eType;
      // pokud zadam bud naslepo nebo jako penup a pak predelam na penmove/pendown, tak by to mohlo fungovat...
      // ale je to slozite a nepruhledne!
      if (sptr->data.event.eType==penUpEvent) {
        if (sptr->data.event.data.penUp.start.x || sptr->data.event.data.penUp.start.y)
          AddPenPoint (sptr->data.event.data.penUp.start.x, sptr->data.event.data.penUp.start.y);
        if (sptr->data.event.data.penUp.end.x || sptr->data.event.data.penUp.end.y)
          AddPenPoint (sptr->data.event.data.penUp.end.x, sptr->data.event.data.penUp.end.y);
        AddPenPoint (sptr->data.event.screenX, sptr->data.event.screenY);
        AddPenPoint (-1, -1);
      } else
      if (sptr->data.event.eType==penDownEvent || sptr->data.event.eType==penMoveEvent) {
        AddPenPoint (sptr->data.event.screenX, sptr->data.event.screenY);
      } else {
        if (sptr->data.event.eType==keyDownEvent && sptr->data.event.data.keyDown.chr==vchrHardPower) {
          FtrGet (AppID, FTR_KEYS, &keys);
          if (keys) break;
        }
        EvtAddEventToQueue (&sptr->data.event);
      }
      break;
    case STEP_text:
      // jak zapsat cely text???
      MemSet (&evt, sizeof (evt), 0);
      evt.eType=keyDownEvent;
      card=0;
      while (card<31 && sptr->data.str[card]) {
        evt.data.keyDown.chr=sptr->data.str[card];
        //evt.data.keyDown.keyCode=
        EvtAddEventToQueue (&evt);
        card++;
      }
      break;
    case STEP_phone:
      // pokud je pozadovany stav shodny se skutecnym stavem, tak nic nedelam a rovnou jdu (bez cekani!) na dalsi krok...
      PhoneState (sptr->data.val);
      break;
    case STEP_BT:
      BTstate (sptr->data.val);
      break;
    case STEP_alarm:
      AlmState (sptr->data.val);
      break;
    case STEP_keyguard:
      HsAttrSet (hsAttrKeyboardLocked, 0, &sptr->data.val);
      break;
  }
  return 0;
}
// ------------------------------------
// hledani dalsiho alarmu
// ------------------------------------
static UInt16 FindAlarm (UInt16 type, UInt32 *altime) {
LocalID         locid;
DmOpenRef       db;
UInt16          tasknum, task, i;
UInt32          date, time, max;
DateTimeType    dt;
MemHandle       hndl;
taskType        *tptr;

  // tady z toho budu muset udelat samostatnou funkci, ktera najde a nastavi dalsi alarm!!!
  // projdu databazi a najdu nejblizsi cas spusteni
  locid=DmFindDatabase (0, MLtasks);
  if (!locid) return -1;
  db=DmOpenDatabase (0, locid, dmModeReadOnly);
  tasknum=-1;
  TimSecondsToDateTime (date=TimGetSeconds (), &dt);
  max=(type==TASK_on)?0:-1;
  // spocitam aktualni tydenni cas
  //lastoff=dt.second+(dt.min+(dt.hour+dt.weekDay*24L)*60)*60;
  time=dt.second+(dt.minute+dt.hour*60L)*60;
  //time=date%(24L*60*60);
  // prohledam databazi
  for (task=0; task<DmNumRecords (db); task++) {
    hndl=DmQueryRecord (db, task);
    if (!hndl) continue;
    tptr=MemHandleLock (hndl);
    if (tptr->weekdays>0x80) {
      if (type==TASK_on) {
        // hledani ulohy pri zapnuti
        // beru prvni max...
        if (tptr->condition==TASK_on && tptr->weekdays&(1<<dt.weekDay) && tptr->time<=*altime && tptr->time>max) {
          tasknum=task;
          max=tptr->time;
          //DEBUGm ("+task: %d\n", task);
        }
      } else {
        // hledani ostatnich uloh
        // uloha pri vypnuti delsim nez
        if (tptr->condition==TASK_after) {
          // hledam to prvni (nejkratsi)
          if (tptr->time<max && type==TASK_after && tptr->time>*altime) {
            tasknum=task;
            max=tptr->time-*altime;
            //DEBUGm ("+task: %d\n", task);
          }
        } else
        if (tptr->condition==TASK_time) {
          // tady musim vypocitat nejblizsi cas
          //for (i=0, tmp=tptr->time; tmp<time || !(tptr->weekdays&(1<<((dt.weekDay+i)%7))); tmp+=24L*60*60, i++);
          for (i=0; tptr->time+i*86400<=time || !(tptr->weekdays&(1<<((dt.weekDay+i)%7))); i++);
          if (tptr->time+i*86400-time<max) {
            tasknum=task;
            max=tptr->time+i*86400-time;
            //DEBUGm ("+task: %d\n", task);
          }
        }
      }
    }
    MemHandleUnlock (hndl);
  }
  DmCloseDatabase (db);
  if (tasknum!=0xFFFF)
    if (!FtrGet (AppID, FTR_BITS, &time))
      if (time & DEBUGLOG_ON) {
        //DEBUG ("type %d\nAlarm: %ld sec for task %d", type, max, tasknum);
        //DEBUGm ("Alarm type %d in %ld seconds (%02d:%02d:%02d) for task %d\n", type, max, dt.hour, dt.minute, dt.second, tasknum);
        DEBUGm ("Alarm type %d in %ld seconds for task %d\n", type, max, tasknum);
      }
  if (type!=TASK_on) *altime=(tasknum!=0xFFFF)?date+max:0;
  // aby byl alarm mirne posunuty od cele minuty, posunu ho tady... Jen aby to nejak neovlivnilo i jine alarmy...
  //if (type!=TASK_on) *altime=(tasknum!=0xFFFF)?date+max+12:0;
  return tasknum;
}
// ------------------------------------
// naplanovani alarmu
// ------------------------------------
void SetTaskAlarm (UInt32 time, UInt16 task) {
alarmType       ainfo, *aptr;
UInt32          tmp;

  // nactu zaznam
  if (FtrGet (AppID, FTR_ALARM, (UInt32*)&aptr))
    return;
  MemMove (&ainfo, aptr, sizeof (ainfo));
  // pokud je rozpracovany ukol, uzavru ho
  if (ainfo.tptr) {
    MemPtrUnlock (ainfo.tptr);
    ainfo.tptr=0;
    ainfo.tasknum=-2;
  }
  // nastavim/smazu alarm
  if (task==0xFFFF) time=0;
  if (AlmGetAlarm (ainfo.card, ainfo.locid, &tmp) != time) {
    AlmSetAlarm (ainfo.card, ainfo.locid, task, time, 0);
    if (!FtrGet (AppID, FTR_BITS, &tmp))
      if (tmp & DEBUGLOG_ON)
        DEBUGm ("Alarm change! (%lu)\n", time);
  }
  // ulozim promenne
  if (ainfo.tasknum!=task) {
    ainfo.tasknum=task;
    if (aptr)
      DmWrite (aptr, 0, &ainfo, sizeof (ainfo));
    FtrSet (AppID, FTR_STEP, 0);
  }
}
// ------------------------------------
// provadeni ulohy
// ------------------------------------
Int16 ExecAlarm (void) {
//void ExecAlarm (UInt16 almCmd, SysAlarmTriggeredParamType *paramP) {
alarmType       ainfo, *aptr;
LocalID         locid;
MemHandle       hndl;
UInt32          step;
UInt8           flags;
DateTimeType    dt;

  if (FtrGet (AppID, FTR_ALARM, (UInt32*)&aptr)) return -1;
  flags=0;
  if (!aptr->db) {
    MemMove (&ainfo, aptr, sizeof (ainfo));
    // otevreni databaze
    locid=DmFindDatabase (0, MLtasks);
    if (!locid) {
      return -2;
    }
    ainfo.db=DmOpenDatabase (0, locid, dmModeReadOnly | dmModeLeaveOpen);
    flags=1;
  }
  if (!aptr->tptr) {
    if (!flags)
      MemMove (&ainfo, aptr, sizeof (ainfo));
    // otevreni zaznamu
    hndl=DmQueryRecord (ainfo.db, ainfo.tasknum);
    //hndl=DmGetRecord (ainfo.db, ainfo.tasknum);
    if (!hndl) {
      if (!aptr->db)
        DmCloseDatabase (ainfo.db);
      return -3;
    }
    // pocet kroku
    ainfo.stepcnt=(MemHandleSize (hndl)-sizeof (taskType))/sizeof (stepType);
/**
    if (!ainfo.stepcnt) {
      DmCloseDatabase (ainfo.db);
      ainfo.db=0;
      return -4;
    }
**/
    // priprava promennych
    ainfo.tptr=MemHandleLock (hndl);
    flags=1;
  }
  // ulozeni features
  if (flags)
    DmWrite (aptr, 0, &ainfo, sizeof (ainfo));
  // nacteni kroku
  if (FtrGet (AppID, FTR_STEP, &step)) step=0;
  if (!step) {
    if (!FtrGet (AppID, FTR_BITS, &step))
      if (step & ALARMLOG_ON) {
        TimSecondsToDateTime (TimGetSeconds (), &dt);
        AlarmLog ("Executing task %d\n", aptr->tasknum);
      }
    step=0;
  }
  // provadeni jednotlivych kroku
  do {
    if (step>=aptr->stepcnt) break;
    ExecStep (&aptr->tptr->step[step]);
    step++;
    if (step>=aptr->stepcnt) break;
  } while (!aptr->tptr->step[step].delay);
  if (step<aptr->stepcnt) {
    // ulozeni kroku
    FtrSet (AppID, FTR_STEP, step);
    // naplanovani dalsiho alarmu
    AlmSetAlarm (aptr->card, aptr->locid, aptr->tasknum, TimGetSeconds  () + aptr->tptr->step[step].delay, 0);
    return 0;
  }
  // uzavreni databaze
  MemPtrUnlock (aptr->tptr);
  DmCloseDatabase (aptr->db);
  // ulozeni promennych
  if (!flags)
    MemMove (&ainfo, aptr, sizeof (ainfo));
  ainfo.tasknum=-1;
  ainfo.db=0;
  ainfo.tptr=0;
  DmWrite (aptr, 0, &ainfo, sizeof (ainfo));
  // nastaveni dalsiho alarmu
  if (!FtrGet (AppID, FTR_BITS, &step))
    if (step & DEBUGLOG_ON)
      DEBUGm ("ExecAlarm\n");
  SetTaskAlarm (step, FindAlarm (TASK_time, &step));
  
  return 1;
}
// ====================================
// contrast popup functions
// ------------------------------------    
static void SetBrightness (FormPtr formP, Int16 brightnessSliderID, Int16 brightnessFieldID, UInt8 brightness, Boolean indexed) {
Int16           brightnessSliderNDX, brightnessFieldNDX;
FieldPtr        fieldP;
Char*           textP;
const UInt8     predefined[12]={0, 4, 5, 6, 9, 18, 40, 60, 90, 120, 180, 255};
UInt8           index, temp;

  if (indexed) {
    if (brightness>11) brightness=11;
    brightness=predefined[index=brightness];
  } else {
    index=0;
    while (brightness>predefined[index] && index<11) index++;
  }
  brightnessSliderNDX = FrmGetObjectIndex( formP, brightnessSliderID );
  brightnessFieldNDX  = FrmGetObjectIndex( formP, brightnessFieldID );
  // get current brightness value
  temp = SysLCDBrightness (false, brightness);
  if (temp != brightness) {
    // save keyboard backlight state
    temp=!(HsCurrentLightCircumstance() & hsLightCircumstanceKeylightOffFlagBit);
    // enable if disabled
    if (!temp) SetKbdBL (true);
    // set LCD brightness
    SysLCDBrightness( true, brightness );
    // restore keyboard backlight state
    if (!temp) SetKbdBL (false);
  }
  // set slider value
  FrmSetControlValue( formP, brightnessSliderNDX, index );
  // show brightness value in textfield
  fieldP   = (FieldPtr)FrmGetObjectPtr( formP, brightnessFieldNDX );
  textP = FldGetTextPtr( fieldP );
  if (textP == NULL)
    textP = (Char*)MemPtrNew(16+32+10);
  if (textP) {
    // maybe show night mode backlight?
    StrPrintF (textP, "%d%% (%d)", (brightness * 100) / 255, brightness);
    FldSetTextPtr( fieldP, textP );
    FldDrawField( fieldP );
  }
}
// ------------------------------------
// nacteni casu z textu
// ------------------------------------
static UInt32 StrGetTime (Char *str) {
UInt32 val, v2;
  val=0;
  do {
    if (*str==':') {val*=60; str++;}
    v2=0;
    while (*str>='0' && *str<='9') {v2*=10; v2+=*str-'0'; str++;}
    val+=v2;
  } while (*str==':');
  return val;
}
// ------------------------------------
// priprava Brightness dialogu
// ------------------------------------
static Boolean OnPopupWinEnterEvent (FormPtr formP) {
UInt8           brightness;
Char            *ptr;
DateTimeType    datetime;
UInt16          offTime, cnt;
Boolean         charge;
void            *cptr;

  brightness = SysLCDBrightness (false, 255); //0 );
  SetBrightness (formP, sliderID_Popup_Brightness, fieldID_Popup_Brightness, brightness, false);
  // show actual time, date and battery charge
  TimSecondsToDateTime (TimGetSeconds (), &datetime);
  SysBatteryInfo (false, NULL, NULL, NULL, NULL, &charge, &brightness);
  ptr=FldGetTextPtr (cptr=FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, fieldID_Popup_txtinfo)));
  if (ptr==NULL) {
    ptr=FldGetTextPtr (FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, fieldID_Popup_Brightness)));
    if (ptr!=NULL) ptr+=16;
  }
  if (ptr) {
    StrPrintF (ptr, "%02d:%02d  %d.%d.%d  %d%%%s", datetime.hour, datetime.minute, datetime.day, datetime.month, datetime.year, brightness, (charge)?"!":"");
    FldSetTextPtr (cptr, ptr);
    FldDrawField (cptr);
  }
  // show actual AutoOff settings
  offTime=SysSetAutoOffTime (0);
  SysSetAutoOffTime (offTime);
  ptr=FldGetTextPtr (FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, fieldID_Popup_Brightness)));
  if (ptr!=NULL) {
    ptr+=16+32;
    StrPrintF (ptr, "%d:%02d", offTime/60, offTime%60);
    CtlSetLabel (cptr=FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, trigID_autoOFF)), ptr);
    CtlDrawControl (cptr);
  }
  // LIST selection
  cnt=LstGetNumberOfItems (cptr=FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, listID_autoOFF)));
  while (cnt) {
    cnt--;
    ptr=LstGetSelectionText (cptr, cnt);
    if (ptr==NULL) continue;
    if (offTime>=StrGetTime (ptr)) break;
  }
  LstSetSelection (cptr, cnt);

  // show actual keyboard backlight settings
  CtlSetValue (FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, chkboxID_KbBL)), !(HsCurrentLightCircumstance() & hsLightCircumstanceKeylightOffFlagBit));
  return true;
}
// ------------------------------------
// zavreni okna Brightness dialogu - uvolneni promennych
// ------------------------------------
static Boolean OnPopupWinExitEvent (FormPtr formP) {
Int16           brightnessFieldNDX;
FieldPtr        fieldP;
Char*           oldTextP;

  brightnessFieldNDX  = FrmGetObjectIndex( formP, fieldID_Popup_Brightness );
  oldTextP = FldGetTextPtr( fieldP = (FieldPtr)FrmGetObjectPtr( formP, brightnessFieldNDX ) );
//  FldSetTextPtr( fieldP, NULL );
//  FldSetTextPtr (FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, fieldID_Popup_txtinfo)), NULL);
//  CtlSetLabel (FrmGetObjectPtr (formP, FrmGetObjectIndex (formP, trigID_autoOFF)), NULL);
  if( oldTextP != NULL )
    MemPtrFree( oldTextP );
  return false;
}
// ------------------------------------
// handler Brightness dialogu
// ------------------------------------
static Boolean BrightnessFormEventHandler (EventPtr eventP) {
Char *str;
UInt16 offTime, val;

FormPtr formP   = FrmGetActiveForm();
Boolean handled = false;

  switch (eventP->eType) {
    case winEnterEvent:
      if (eventP->data.winEnter.enterWindow==FrmGetWindowHandle (formP)) {
        OnPopupWinEnterEvent (formP);
      }
      break;
    case ctlRepeatEvent:
      if (eventP->data.ctlRepeat.controlID == sliderID_Popup_Brightness) {
	SetBrightness (formP, sliderID_Popup_Brightness, fieldID_Popup_Brightness, eventP->data.ctlRepeat.value, true);
      }
      break;
    case ctlSelectEvent:
      switch (eventP->data.ctlSelect.controlID) {
        case sliderID_Popup_Brightness:
	  SetBrightness (formP, sliderID_Popup_Brightness, fieldID_Popup_Brightness, eventP->data.ctlSelect.value, true);
	  break;
        case chkboxID_KbBL:
          SetKbdBL (eventP->data.ctlSelect.on);
          break;
      }
      break;
    case popSelectEvent:
      if (eventP->data.popSelect.listID == listID_autoOFF) {
        str=LstGetSelectionText (eventP->data.popSelect.listP, eventP->data.popSelect.selection);
        offTime=60; val=0;
        while (*str>='0' && *str<='9') {val*=10; val+=*str-'0'; str++;}
        if (*str==':') {offTime=val*60; str++;}
        val=0;
        while (*str>='0' && *str<='9') {val*=10; val+=*str-'0'; str++;}
        if (val) offTime+=val;
        SysSetAutoOffTime (offTime);
      }
      break;
//    case keyDownEvent:
//      break;
    default:
      break;
  }
  return handled;
}
