/*************************************
 MultiLauncher 0.3.0
 (C) 2005-2007 Hynek Sladky
 sladky@mujmail.cz
*************************************/

#define ALLOW_ACCESS_TO_INTERNALS_OF_WINDOWS
#define ALLOW_ACCESS_TO_INTERNALS_OF_FORMS
#define ALLOW_ACCESS_TO_INTERNALS_OF_FIELDS

#include <PalmOS.h>
#include <PalmChars.h>
// ------------------------------------
// Handspring/Treo specific includes
// ------------------------------------
#include <PmSysGadgetLib.h>
#include <PmSysGadgetLibCommon.h>
#include <HsCreators.h>
#include <HsChars.h>
#include <HsKeyCodes.h>
#include <HsExt.h>
#include <HsKeyTypes.h>
#include <HsPhone.h>
#include <TonesLibTypes.h>
#include <TonesLib.h>
// ------------------------------------
// other includes
// ------------------------------------
#include <ByteOrderUtils.h>
// ------------------------------------
// resources header
// ------------------------------------
#include "MLaunchR.h"
#include "MLaunch.h"
#include "version.h"
extern const char *build, *build_date, *build_time;
// ------------------------------------
// defines
// ------------------------------------
#define MAIN_ENABLE                     // povoli ML enable na hlavni obrazovce...

/******** ToDo ********/
/**********************
OPRAVY:
======
? kdyz jsem pridal zaznam (task), tak popuplist se jmeny tasku hodil chybu...
? nekdy pri ruznych zmenach kroku se zmatou nejake promenne a pristupuje se asi na NULL
- kdyz smazu posledni task, tak zustane list (kroky) vyplneny!
- mozna kdyz prefs.tasknum vyjede kvuli mazani z poctu zaznamu, tak to taky bude zlobit???
  jinymi slovy: ShowTask by mel korektne zpracovat i out_of_bounds index...
- po urcite dobe spanku (30 minut?) POSE vytuhnul... (tj. musel jsem ho ukoncit; Alt+R jsem nezkousel ale win32 aplikace nereagovala...)
- listbox at/after/while nereflektuje aktualni nastaveni tasku
- listbox eventu nereflektuje vybrany event...
o list pro vyber aplikace a eventu nenastavi aplikace od prvniho radku!

UPRAVY:
======
- po resetu se zobrazi Attention, pokud doslo k resetu
  v preferencich se pamatuje, jaky byl cas posledniho resetu...
  pri prohlednuti reset logu se zapamatuje nejvyssi prohlednute datum
- do dialogu pro nastaveni podsviceni dodelat rychlou volbu na zap/vyp klavesnice:
  stiskne se pismeno, ktere zmeni stav podsviceni klavesnice a zaroven ukonci dialog
- parsovani SystemErrorLogu: funkce ShowErrorLog
  <Text>
  - odfiltrovat <Func>nazev funkce</Func><Err>cislo chyby</Err><Text>popis chyby</Text>
    <Text>udalost: dalsi informace</Text>
    <Text>Reset: datum, cas (type/creator),duvod udalosti</Text>
    udelat parsovani vsech XML tagu... "Func: %s\nError: %s\nApp: %s (%s/%s)\n%s"
    zkusit najit prislusnou aplikaci; pokud ji nenajdu, zobrazit type/creator
    zkontrolovat, zda dane type/creator je jen jednou; pokud je vickrat, tak to take zobrazit!

- checkbox: log tasks, DEBUG log
? checkbox: plan alarms on reset

- AlarmGadget
  - zkusit prepsat, aby vracel novou hodnotu
    jenze to bych po SetPref musel volat GetPref, aby to bylo korektni...
  - projit si to, protoze pry je SetPref casove narocne (NVFS...)

x pro HiRes prepocitat souradnice penUp
  - zatim bych to videl tak, ze kdyz to bude na HiRes, tak si to uzivatel nastavi sam...
    navic by bylo nejjednodussi upravit funkci AddPoint, jenze to by znamenalo vicenasobne volani nasledujicich funkci...
    tak to zatim opravdu necham na uzivateli
  FtrGet (sysFtrCreator, sysFtrNumWinVersion, &version);
  if (version>=4) {
    WinScreenGetAttribute (winScreenDensity, &attr);
    (attr/kDensitySingle) = 1.0/1.5/2.0 ...

- AutoVer
  - sprava ARJ a ZIP archivu...
  - mozna by slo delat zip archiv (i arj) do _not_archived_... ?
    je otazka, zda toto pujde pomoci ZIP
  - resp. pak by stalo za zvazeni mit zdrojaky v podadresari SRC...

gadgets:
- poradne si projit DateAgenda.c:AgendaDividerDraw (GadgetHandler)
- spravna podpora klikani
- zpracovani kliknuti...
  asi tak, ze se posle dalsi event...
  aspon jsem to nekde videl... v examples...

TASKS:
======
- hit control (CtlHitControl)
- tap display (penDown/Up event - viz CBar)
- enter/insert text (asi keyDown)
- GSM (On/Off/SMS/...? silent mode...? vzdy od 18:00-19:00, ne:9:00-10:30?)
  PhnLibSetModulePower (refNum, Boolean);
  PhoneOn/Off
  BtOn/Off
  AlarmsOn/Off

Hotovo:
=======
x rucne jsem vypnul a zapnul a pustil se task_ON >= 3:00 !!!
  bud KeyCurrentState () pri Sleep nereflektuje stisknute tlacitko ESC nebo tam je jeste nekde chyba
  - power off se generuje pri pusteni tlacitka power, takze (zatim:-) nevim, podle ceho toto zjistit!!!
? z nejakeho podivneho duvodu to neusne, ale stale to usina...
  je divne, ze to dokola opakuje jen task 5
  - vypada to na chybu POSE... dela to jen obcas... na Treo650sim to funguje...
o Treo650sim: SysCurDatabase vrati informace o aktualni UI aplikaci, takze pokud neni aktivni MLtask, tak spousta veci nechodi!!!
  takze pri naplanovani alarmu musim najit MLaunch a k tomu odpovidajici (card a) locid... !!!
  nebo pri zapnuti do FTR_ALARM ulozit card i locid... a pouzivat toto...
o na Treo650 nejde zadat novou ulohu...
  na Treo650sim to jde...
  aha: mel jsem tam nejakou starou nekompatibilni databazi...
o rozdelit na UI a notifikace
  tj. kde se pouzivaji globals a kde ne...
o checkbox pro DEBUGlog???
  ale chtelo by to logovat jinam nez do memopadu nebo do memopadu, ale do zaznamu s textem ML_log...
  pokud neni, tak ho vytvori...
o pri stisku HOME se prepnout z task do launcheru
  ale jen kdyz MLaunch je aktivni launcher!!!
o do automatickych akci dat jeste vypnuti/zapnuti telefonu, nastaveni hlasiteho/ticheho rezimu
x kdyz dojde k RESETu, tak se zacykli, pokud je povoleny scheduler!!!
  budu muset zjistit, ktera cas inicializace scheduleru za to muze...
  -> asi to je FindAlarm...
  mozna by slo napsat si malou aplikaci, ktera bude obsahovat jen PilotMain a FindAlarm
    bude logovat do MemoPadu
    ale budu muset obsahovat nejaky zpusob jak ji zakazat (v nejhorsim smazat...)
    idealni by bylo kdyby po resetu fungovala jen jednou...
    napr. pri spusteni si ulozi do preferenci ze uz byla spustena
    v UI bude obsahovat checkbox pro opetovne povoleni a tlacitko reset...
  - to by me teda zajimalo, zda se to stale cykli i kdyz jsem rozdelil UI/notifikace
    asi bych mohl povolit checkboxem aktivaci tasku po resetu...
    na druhou stranu se povoli pri nejblizsim vypnuti (auto-off)
o zapis DEBUG log do nove databaze, nikoliv do stare kompatibilni!
  mozna to zpusobovalo cyklicky reset???
  "MemoDB.pdb" DATA memo -> "MemosDB-PMem.pdb" DATA PMem
  -> krome zmeny jmena a creatoru se nic na databazi nezmenilo...
  - zkousel jsem v Treo simulatoru reset, ale vse fungovalo... budu muset zkusit realne zarizeni...
o informace o resetu
  text "No system errors recorded in log." je v souboru HsExtensions2.0_enUS.prc a PmSystemLib-PmSy_enUS.prc
  kod 377 je v souboru GSMActivation.prc a MMSTransport.prc
  Zobrazeni System Error Log je v PmSystemLib-PmSy-enUS.prc a HsExtensions2.0_enUS.prc
  -> mozne hlasky:
    A reset was  caused on ^1 while running "^3":\n^2
    A crash occured on ^1 while running "^3"\n^2
    No system errors recorded in log.
  jako format je tam (HsExtensions2.0.prc) uvedeno: 
    Reset: %s, %s (%c%c%c%c/%c%c%c%c),%s
    <Func>%s</Func><Text>%s</Text>
    <Err>%x</Err><Text>%s</Text>
    <Func>%s</Func><Err>%x</Err><Text>%s</Text>
    <Evt>%s</Evt><Text>%s</Text>
    <Evt>%x</Evt><Text>%s</Text>
  database: "HsTraceDatabase.pdb" HsTr HsTr
  aplikace TraceCrash (freeware - bez zdrojaku; zkusit a podivat se, co navic se jeste zobrazuje)
***********************/
// ====================================
// DEBUG functions
// ------------------------------------
// UI debug window
// ------------------------------------
#include <stdarg.h>
static void DEBUG (char *a, ...) {
char *b = MemPtrNew(256);
va_list p;
  va_start(p, a);
  StrVPrintF(b, a, p);
  FrmCustomAlert (show, b, "", "");
  va_end(p);
  MemPtrFree(b);
}
// ====================================
// global variables
// ------------------------------------
// ML preference
// ------------------------------------
PrefsType Prefs = {
  0x00000000, 0, 0
};
// ------------------------------------
// sound preference backup
// ------------------------------------
SoundPrefBackupType SndBack[soundPrefTypeLast];
// ------------------------------------
// ML UI globals
// ------------------------------------
Char                    **appslist;
SysDBListItemType       *apps_ptr;
UInt16                  appscnt;
DmOpenRef               cacheDB;

// 0/1-4/5-20/21-84
#define TopMin          21
#define TopMax          84

UInt16                  state;
Char                    statestr[10];

#define SelPressed      0x0001
UInt16                  flags;
// ------------------------------------
// task UI globals
// ------------------------------------
Char                    **tasklist;
Char                    **steplist;
Char                    **actions;
Char                    *evtstr;
Char                    **events;

UInt16                  taskcnt, stepcnt, evtcnt;

//#define MaxTasks        256
#define MaxTasks        32
//#define MaxSteps        256
#define MaxSteps        32
// promenne pro ulozeni zobrazenych dat
taskType                tval;
stepType                sval;
Char                    ttype[8];
// ------------------------------------
// database globals
// ------------------------------------
DmOpenRef               taskDB;
// ------------------------------------
// string for date, time and battery message
// ------------------------------------
Char                    dtb[80];
Boolean                 showRecent;
// ------------------------------------
// Treo gadgets library
// ------------------------------------
UInt16 gPmSysGadgetLibRefNum;
// ====================================
// resource database functions
// ------------------------------------
// removing resource
// ------------------------------------
static Err RemoveResource (UInt32 type, UInt16 ID) {
UInt16 i;

  i=DmFindResource (cacheDB, type, ID, NULL);
  if (i!=0xFFFF)
    DmRemoveResource (cacheDB, i);
  return 0;
}
// ------------------------------------
// saving resource
// ------------------------------------
static Err SaveResource (void *ptr, UInt32 size, UInt32 type, UInt16 ID) {
MemHandle hndl;

  hndl=DmNewResource (cacheDB, type, ID, size);
  if (hndl==NULL) return 1;
  DmWrite (MemHandleLock (hndl), 0, ptr, size);
  MemHandleUnlock (hndl);
  DmReleaseResource (hndl);
  return 0;
}
// ====================================
// Ir gadget functions
// ------------------------------------
// drawing gadget On/Off button
// ------------------------------------
static void DrawServiceButton (FormGadgetType *gptr, Boolean sel, DmResID bmp_id) {
RectangleType   rect;
UInt16          i;
MemHandle       hndl;
BitmapPtr       bptr;
  MemMove (&rect, &gptr->rect, sizeof (rect));
  // erasing whole area w/o frame
  WinEraseRectangle (&rect, 0);
  // filling area w/o frame
  if (sel) {
    i=WinSetForeColor (UIColorGetTableEntryIndex (UIObjectSelectedFill));
    WinDrawRectangle (&rect, 0); 
    WinSetForeColor (i);
  }
  hndl=NULL;
  //value=(UInt32)gptr->data;
  //value=GetIrState ();
  //if (value>=0) {
  //  hndl=DmGetResource ('Tbmp', value?pict_IRon:pict_IRoff);
  //}
  if (bmp_id)
    hndl=DmGetResource ('Tbmp', bmp_id);
  if (hndl!=NULL) {
    bptr=MemHandleLock (hndl);
/**
    BmpGetDimensions (bptr, &rect.extent.x, &rect.extent.y, NULL);
    if (rect.extent.y>12) rect.extent.y=12;
    if (rect.extent.x>8) rect.extent.x=8;
    rect.topLeft.x=gptr->rect.topLeft.x+(gptr->rect.extent.x-rect.extent.x)/2;
    rect.topLeft.y=gptr->rect.topLeft.y+(gptr->rect.extent.y-rect.extent.y)/2;
    WinSetClip (&rect);
**/
    WinDrawBitmap (bptr, rect.topLeft.x, rect.topLeft.y);
    MemHandleUnlock (hndl);
    DmReleaseResource (hndl);
//    WinResetClip ();
    gptr->attr.visible=true;
  } else {
    gptr->attr.visible=false;
  }
/**/
/**
  i=WinSetForeColor (UIColorGetTableEntryIndex (UIObjectFrame));
  MemMove (&rect, &gptr->rect, sizeof (rect));
  WinDrawRectangleFrame (roundFrame, &rect);
**/
}
// ------------------------------------
// Ir gadget handler
// ------------------------------------
static Boolean IrGadgetHandler (struct FormGadgetType *gadgetP, UInt16 cmd, void *paramP) {
Boolean handled;
Int16   value;
  handled=false;
  switch (cmd) {
    case formGadgetDrawCmd:
      value=GetIrState ();
      DrawServiceButton (gadgetP, false, value<0?0:(value?pict_IRon:pict_IRoff));
      handled=true;
      break;
    case formGadgetHandleEventCmd:
      if (((EventPtr)paramP)->eType==frmGadgetEnterEvent) {
        // state change after tapping
        SetIrState (!GetIrState ());
        value=GetIrState ();
        DrawServiceButton (gadgetP, false, value<0?0:(value?pict_IRon:pict_IRoff));
        handled=true;
      }
      if (((EventPtr)paramP)->eType==frmGadgetMiscEvent) {
      }
      break;
    case formGadgetDeleteCmd:
      break;
    case formGadgetEraseCmd:
      break;
  }
  return handled;
}
// ------------------------------------
// Alarm gadget handler
// ------------------------------------
static Boolean AlmGadgetHandler (struct FormGadgetType *gadgetP, UInt16 cmd, void *paramP) {
Boolean handled;
Int16   value;
  handled=false;
  switch (cmd) {
    case formGadgetDrawCmd:
      value=AlmState (-1);
      DrawServiceButton (gadgetP, false, value<0?0:(value?pict_AlmOn:pict_AlmOff));
      handled=true;
      break;
    case formGadgetHandleEventCmd:
      value=AlmState (-1);
      if (((EventPtr)paramP)->eType==frmGadgetEnterEvent) {
        // change state after tapping
        if (value>=0) {
          value=AlmState (!value);
          // protoze vraci prechozi hodnotu, musim znovu zjistit stav!
          value=AlmState (-1);
        }
      }
      // redraw gadget (in spite of both frmGadgetMiscEvent and frmGadgetEnterEvent)
      //if (((EventPtr)paramP)->eType==frmGadgetMiscEvent) {
      DrawServiceButton (gadgetP, false, value<0?0:(value?pict_AlmOn:pict_AlmOff));
      handled=true;
      //}
      break;
    case formGadgetDeleteCmd:
      break;
    case formGadgetEraseCmd:
      break;
  }
  return handled;
}
// ====================================
// button drawing
// ------------------------------------
// drawing one small button
// ------------------------------------
static void DrawOneSmallButton (UInt16 level, Int16 x, Int16 y) {
RectangleType   rect;
MemHandle       hndl;
UInt16          i;

  rect.topLeft.x=x; rect.topLeft.y=y;
  rect.extent.x=16; rect.extent.y=10;
  WinEraseRectangle (&rect, 0);
  if (level>TopMax) return;
  hndl=NULL;
  i=DmFindResource (cacheDB, 'tICO', 2000+level, NULL);
  if (i!=0xFFFF)
    hndl=DmGetResourceIndex (cacheDB, i);
  if (hndl!=NULL) {
    WinSetClip (&rect);
    WinDrawBitmap (MemHandleLock (hndl), rect.topLeft.x, rect.topLeft.y);
    MemHandleUnlock (hndl);
    DmReleaseResource (hndl);
    WinResetClip ();
  }
}
// ------------------------------------
// drawing all four small buttons
// ------------------------------------
static void DrawFourSmallButtons (UInt16 level, Int16 x, Int16 y, Boolean vertical) {
UInt16 cnt;
//  DEBUG ("small: %d", level+1);
  for (cnt=4; cnt; cnt--) {
    level++;
    DrawOneSmallButton (level, x, y);
    if (vertical) x+=16; else y+=10;
  }
}
// ------------------------------------
// drawing one big button and four belonging small buttons
// ------------------------------------
static void DrawOneButton (FormGadgetType *gptr, Boolean sel) {
RectangleType   rect;
UInt16          i, level;
MemHandle       hndl;
BitmapPtr       bptr;
FormPtr         frm;
//SysDBListItemType *dbptr;
FieldPtr        fld;
Char            *str;

  MemMove (&rect, &gptr->rect, sizeof (rect));
  // erasing whole area w/o frame
  WinEraseRectangle (&rect, 0);
  // filling area w/o frame
  if (sel) {
    i=WinSetForeColor (UIColorGetTableEntryIndex (UIObjectSelectedFill));
    WinDrawRectangle (&rect, 0); 
    WinSetForeColor (i);
  }

  hndl=NULL;
  level=(UInt32)gptr->data;
  if (level<=TopMax) {
    i=DmFindResource (cacheDB, 'tICO', 1000+level, NULL);
    if (i!=0xFFFF)
      hndl=DmGetResourceIndex (cacheDB, i);
  }
  if (hndl!=NULL) {
    bptr=MemHandleLock (hndl);
    BmpGetDimensions (bptr, &rect.extent.x, &rect.extent.y, NULL);
    if (rect.extent.y>22) rect.extent.y=22;
    if (rect.extent.x>32) rect.extent.x=32;
    rect.topLeft.x=gptr->rect.topLeft.x+(gptr->rect.extent.x-rect.extent.x)/2;
    rect.topLeft.y=gptr->rect.topLeft.y+(gptr->rect.extent.y-rect.extent.y)/2;
    WinSetClip (&rect);
    WinDrawBitmap (bptr, rect.topLeft.x, rect.topLeft.y);
    MemHandleUnlock (hndl);
    DmReleaseResource (hndl);
    WinResetClip ();
  }
  i=WinSetForeColor (UIColorGetTableEntryIndex (UIObjectFrame));
  MemMove (&rect, &gptr->rect, sizeof (rect));
  WinDrawRectangleFrame (roundFrame, &rect);
  // drawing app name
  i=0;
  switch (gptr->id) {
    case ML_button_U:
      i=ML_name_U;
      break;
    case ML_button_D:
      i=ML_name_D;
      break;
    case ML_button_L:
      i=ML_name_L;
      break;
    case ML_button_C:
      i=ML_name_C;
      break;
    case ML_button_R:
      i=ML_name_R;
      break;
  }
  if (i) {
    frm=FrmGetActiveForm ();
    fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, i));
    hndl=NULL;
    str=NULL;
    if (level<=TopMax) {
      // nejdriv se podivam na 'tAIN'
      i=DmFindResource (cacheDB, 'tAIN', 1000+level, NULL);
      if (i!=0xFFFF) {
        hndl=DmGetResourceIndex (cacheDB, i);
        if (hndl!=NULL) {
          str=MemHandleLock (hndl);
        }
      }
      // pokud neni 'tAIN', tak zobrazim filename z 'tPRC'
      if (str==NULL) {
        i=DmFindResource (cacheDB, 'tPRC', 1000+level, NULL);
        if (i!=0xFFFF) {
          hndl=DmGetResourceIndex (cacheDB, i);
          if (hndl!=NULL) {
            str=((SysDBListItemType*)MemHandleLock (hndl))->name;
          }
        }
      }
    }
    if (hndl!=NULL) {
      FldSetTextPtr (fld, str);
      //FldRecalculateField (fld, true);
      FldDrawField (fld);
      MemHandleUnlock (hndl);
      DmReleaseResource (hndl);
    } else {
      FldSetTextPtr (fld, "");
      FldDrawField (fld);
    }
  }
  // drawing subsequent small icons
  switch (gptr->id) {
    case ML_button_U:
      DrawFourSmallButtons (level*4, gptr->rect.topLeft.x-15, gptr->rect.topLeft.y-12, true);
      break;
    case ML_button_D:
      DrawFourSmallButtons (level*4, gptr->rect.topLeft.x-15, gptr->rect.topLeft.y+gptr->rect.extent.y+3, true);
      break;
    case ML_button_L:
      DrawFourSmallButtons (level*4, gptr->rect.topLeft.x-19, gptr->rect.topLeft.y-8, false);
      break;
    case ML_button_R:
      DrawFourSmallButtons (level*4, gptr->rect.topLeft.x+gptr->rect.extent.x+4, gptr->rect.topLeft.y-8, false);
      break;
  }
}
// ------------------------------------
// draw all five big buttons with all small buttons
// ------------------------------------
static void DrawButtons (FormPtr frm, Boolean all) {
UInt16 i;
  FrmSetGadgetData (frm, i=FrmGetObjectIndex (frm, ML_button_C), (void*)(state+0L));
  DrawOneButton (FrmGetObjectPtr (frm, i), false);
  if (!all) return;
  // drawing all buttons
  FrmSetGadgetData (frm, i=FrmGetObjectIndex (frm, ML_button_U), (void*)(state*4+1L));
  DrawOneButton (FrmGetObjectPtr (frm, i), false);
  FrmSetGadgetData (frm, i=FrmGetObjectIndex (frm, ML_button_D), (void*)(state*4+2L));
  DrawOneButton (FrmGetObjectPtr (frm, i), false);
  FrmSetGadgetData (frm, i=FrmGetObjectIndex (frm, ML_button_L), (void*)(state*4+3L));
  DrawOneButton (FrmGetObjectPtr (frm, i), false);
  FrmSetGadgetData (frm, i=FrmGetObjectIndex (frm, ML_button_R), (void*)(state*4+4L));
  DrawOneButton (FrmGetObjectPtr (frm, i), false);
}
// ------------------------------------
// handler for big launcher buttons
// ------------------------------------
static Boolean ButtonHandler (struct FormGadgetType *gadgetP, UInt16 cmd, void *paramP) {
Boolean handled;
  handled=false;
  switch (cmd) {
    case formGadgetDrawCmd:
      DrawOneButton (gadgetP, false);
      gadgetP->attr.visible=true;
      handled=true;
      break;
    case formGadgetHandleEventCmd:
      if (((EventPtr)paramP)->eType==frmGadgetEnterEvent) {
        Boolean selected;
        Int16 pntx, pnty;
        Boolean penDown=true;
        EventType nevt;
        UInt16 delay, ddelay, period;
        Boolean qahead;
        UInt16 tps;//=SysTicksPerSecond ()/10;
        // tracking the pen
        KeyRates (false, &delay, &period, &ddelay, &qahead);
        tps=delay/10;
        period=0;
        // if the button is pressed at least -> holding button
        DrawOneButton (gadgetP, selected=true);
        while (penDown && period<delay) {
          EvtGetPen (&pntx, &pnty, &penDown);
          if (RctPtInRectangle (pntx, pnty, &gadgetP->rect)) {
            if (!selected)
              DrawOneButton (gadgetP, selected=true);
          } else {
            period=0;
            if (selected)
              DrawOneButton (gadgetP, selected=false);
          }
          SysTaskDelay (tps);
          period+=tps;
        }
        if (selected) {
          DrawOneButton (gadgetP, false);
          nevt.eType=(penDown)?frmGadgetHoldEvent:frmGadgetSelectEvent;
          nevt.data.ctlSelect.controlID=gadgetP->id;
          EvtAddEventToQueue (&nevt);
          SndPlaySystemSound (sndClick);
        }
        handled=true;
      }
      if (((EventPtr)paramP)->eType==frmGadgetMiscEvent) {
      }
      break;
    case formGadgetDeleteCmd:
      //DrawOneButton (state, 80, 80, false);
      break;
    case formGadgetEraseCmd:
      //DrawOneButton (state, 80, 80, false);
      break;
  }
  return handled;
}
// ====================================
// switching to selected application
// ------------------------------------
static Err RunSelectedApp (void) {
UInt16          i;
MemHandle       hndl;
SysDBListItemType *ptr;
LocalID         dbid;

  i=DmFindResource (cacheDB, 'tPRC', 1000+state, NULL);
  if (i==0xFFFF) return 1;
  hndl=DmGetResourceIndex (cacheDB, i);
  if (hndl==NULL) return 2;
  ptr=MemHandleLock (hndl);
  // spousteni podle dbid - po resetu nemusi byt spolehlive!
  //i=SysUIAppSwitch (ptr->cardNo, ptr->dbID, sysAppLaunchCmdNormalLaunch, NULL);
  // spousteni podle nazvu
  dbid=DmFindDatabase (ptr->cardNo, ptr->name);
  if (dbid) {
    SysUIAppSwitch (ptr->cardNo, dbid, sysAppLaunchCmdNormalLaunch, NULL);
  }
  MemHandleUnlock (hndl);
  DmReleaseResource (hndl);
  return i;
}
// ====================================
// other support functions
// ------------------------------------
// printing selected step level
// ------------------------------------
static void ShowStepLevel (FormPtr frm) {
FieldPtr fld;
  StrPrintF (statestr, "%d", state);
  FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, selnumber)), statestr);
  FldDrawField (fld);
}
// ------------------------------------
// moving in levels forward
// ------------------------------------
static void NextLevel (FormPtr frm, UInt16 step) {
  if (state>=TopMin) return;
  state*=4;
  state+=step;
  //DEBUG ("New state: %d", state);
  DrawButtons (frm, true);
  ShowStepLevel (frm);
}
// ------------------------------------
// moving in levels backward
// ------------------------------------
static void PrevLevel (FormPtr frm) {
  if (!state) return;
  state-=1;
  state/=4;
  DrawButtons (frm, true);
  ShowStepLevel (frm);
}
// ====================================
// creating list of all applications
// ------------------------------------
static Err LoadDatabaseList (void) {
MemHandle       listhndl;
UInt16          i, j;
Int16           k;

  listhndl=NULL;
  if (apps_ptr!=NULL) return 0;
  // loading apps list
  if (SysCreateDataBaseList ('appl', 0, &appscnt, &listhndl, false)) {
//  if (SysCreateDataBaseList ('appl', 0, &appscnt, &listhndl, true)) { // returns 'tAIN' AppsIconName :-( and sorts list! :-) BUT! doesn't return Launcher in list!!!
    if (appscnt>0)
      apps_ptr=MemHandleLock (listhndl);
  }
  if (!appscnt || apps_ptr==NULL || listhndl==NULL) return cantRunApp;
  // creating sorted list
  appslist=MemPtrNew (appscnt*sizeof (Char*));
  if (appslist==NULL) return cantRunApp;
  // the simplest algorithm I know...
  for (i=0; i<appscnt; i++) {
    for (j=0; j<i; j++) {
      k=StrCompare (apps_ptr[i].name, appslist[j]);
      if (k<0) break;
    }
    for (k=i; k>j; k--)
      appslist[k]=appslist[k-1];
    appslist[k]=apps_ptr[i].name;
  }
  return 0;
}
// ====================================
// System Error Log list
// ------------------------------------    
void ShowErrorLog (void) {
LocalID         locid;
DmOpenRef       dbtr;
UInt16          rcnt, i, j, rofs;
Char            **rlst;
ListPtr         lst;
typedef struct {
  UInt32 tmp1;
  UInt32 log_app; // 'HsEx'
  UInt32 log_type; // 'HsEx'
  UInt32 tmp2;
  UInt32 time;
  UInt32 tmp3;
  UInt32 len;
  Char text[1];
} HsTraceStruct;
HsTraceStruct   *rptr;
MemHandle       hndl;
DateTimeType    dt;
FormPtr         frm;
UInt32          maxdate, actdate;
Char            *sfnc, *serr, *stxt, *sevt, *s;
UInt32          *type, *creator;
DmSearchStateType sinfo;
  locid=DmFindDatabase (0, "HSTraceDatabase");
  if (locid) {
    dbtr=DmOpenDatabase (0, locid, dmModeReadOnly);
    if (dbtr) {
      rcnt=DmNumRecords (dbtr);
      //DEBUG ("TraceDB: %d records", rcnt);
      if (!rcnt) {
        DmCloseDatabase (dbtr);
        DEBUG ("No records in ErrorLog!");
        return;
      }
      rofs=0;
      if (rcnt>1200) {
        rofs=rcnt-1200;
        rcnt=1200;
      }
      //DEBUG ("Offs: %d, Count: %d", rofs, rcnt);
      // vytvoreni seznamu
      // asi by bylo potreba vytvorit setrideny seznam... vypada to, ze zaznamy jsou nejak divne nahodne
      // mozna by v prvni chvili bylo uzitecne si prevest obe databaze do textove podoby... takze app pro win32console
      // Treo ma asi kruhovy buffer? Simulator pridava nakonec kazde vypnuti a dalsi informace (takze ma prilis velkou databazi!)
      rlst=MemPtrNew ((rcnt+1)*sizeof (Char*));
      if (rlst) {
        *rlst=MemPtrNew (1500+rcnt*48); // POZOR! Maximalni velikost je mensi nez 64KB!!!
        if (*rlst) {
          for (i=1; i<rcnt; i++)
            rlst[i]=rlst[i-1]+48;
          maxdate=0;
          j=0;
          for (i=0; i<rcnt; i++) {
            //hndl=DmQueryRecord (dbtr, rofs+rcnt-i-1); // v simulatoru to radi postupne, ale je jich pres 2000, v Treo650 je (asi) kruhovy buffer jen cca 19
            hndl=DmQueryRecord (dbtr, rofs+i);
            if (hndl) {
              rptr=MemHandleLock (hndl);
              actdate=EndianSwap32 (rptr->time);
              if (actdate>=maxdate) {maxdate=actdate; j=i;}
              TimSecondsToDateTime (actdate, &dt);
              //StrPrintF (rlst[i], "%d: %d.%d.%d %02d:%02d:%02d", rofs+rcnt-i-1, dt.day, dt.month, dt.year, dt.hour, dt.minute, dt.second);
              StrPrintF (rlst[i], "%d.%d.%d %02d:%02d:%02d", dt.day, dt.month, dt.year, dt.hour, dt.minute, dt.second);
              MemHandleUnlock (hndl);
            } else {
              StrPrintF (rlst[i], "<%d unaccessible>", rofs+rcnt-i-1);
            }
          }
          frm=FrmGetActiveForm ();
          LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_apps)), rlst, rcnt);
          LstSetSelection (lst, j);
          LstMakeItemVisible (lst, j);
          i=LstPopupList (lst);
          if (i!=noListSelection) {
            //hndl=DmQueryRecord (dbtr, rofs+rcnt-1-i);
            hndl=DmQueryRecord (dbtr, rofs+i);
            if (hndl) {
              rptr=MemHandleLock (hndl);
              // kopie do RAM
              MemMove (s=rlst[0], rptr->text, j=EndianSwap32 (rptr->len));
              s[j]=0;
              // parsovani textoveho popisu
              sfnc=serr=sevt=stxt=NULL;
              type=creator=0;
              while (*s) {
                if (*s=='<') {
                  if (s[1]=='/') {
                    *s=0;
                  } else                    
                  if (!StrNCompare (s, "<Func>", 6)) {
                    s+=5;
                    sfnc=s+1;
                  } else
                  if (!StrNCompare (s, "<Err>", 5)) {
                    s+=4;
                    serr=s+1;
                  } else
                  if (!StrNCompare (s, "<Evt>", 5)) {
                    s+=4;
                    sevt=s+1;
                  } else
                  if (!StrNCompare (s, "<Text>", 6)) {
                    s+=5;
                    stxt=s+1;
                  } else {
                    DEBUG ("Unknown XML tag!");
                  }
                }
                s++;
              }
              s++;
              if (!stxt) stxt=rlst[0];
              // parsovani Reset udalosti
              if (!StrNCompare (stxt, "Reset:", 6)) {
                stxt+=6;
                // preskocim datum a cas
                while ((*stxt>='0' && *stxt<='9') || *stxt=='.' || *stxt==',' || *stxt==':' || *stxt==' ') stxt++;
                if (*stxt=='(' && stxt[5]=='/' && stxt[10]==')') {
                  type=(UInt32*)&stxt[1];
                  creator=(UInt32*)&stxt[6];
                  stxt+=11;
                }
                if (*stxt==',') stxt++;
              }
              // zobrazeni informaci o udalosti
              // POZOR! pokud bude jen jeden zaznam, nebude misto pro ukazatel rlst[1]!!!
              rlst[1]=s;
              // datum/cas
              TimSecondsToDateTime (EndianSwap32 (rptr->time), &dt);
              s+=StrPrintF (s, "%d.%d.%d %02d:%02d:%02d\n", dt.day, dt.month, dt.year, dt.hour, dt.minute, dt.second);
              // aplikace
              if (type && creator) {
                i=0;
                if (DmGetNextDatabaseByTypeCreator (true, &sinfo, *type, *creator, false, &j, &locid)==errNone) {
                  DmDatabaseInfo (j, locid, s, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
                  if (DmGetNextDatabaseByTypeCreator (false, &sinfo, *type, *creator, false, &j, &locid)==errNone) {
                    s+=StrPrintF (s, "ambiguous application");
                  } else {
                    while (*s) s++;
                  }
                } else {
                  s+=StrPrintF (s, "unknown application");
                }
                s+=StrPrintF (s, " (%c%c%c%c/%c%c%c%c)\n", ((Char*)type)[0], ((Char*)type)[1], ((Char*)type)[2], ((Char*)type)[3], ((Char*)creator)[0], ((Char*)creator)[1], ((Char*)creator)[2], ((Char*)creator)[3]);
              }
              // popis chyby
              s+=StrPrintF (s, "%s\n", stxt);
              // dalsi informace
              if (sfnc)
                s+=StrPrintF (s, "Func: %s\n", sfnc);
              if (serr)
                s+=StrPrintF (s, "Err: %s\n", serr);
              if (sevt)
                s+=StrPrintF (s, "Event: %s\n", sevt);
              //
              MemHandleUnlock (hndl);
              s--;
              if (*s=='\n') *s=0;
              DEBUG (rlst[1]);
            }
          }
          MemPtrFree (*rlst);
        } else
          DEBUG ("Memory allocation error!");
        MemPtrFree (rlst);
      } else
        DEBUG ("Memory allocation error!");
      DmCloseDatabase (dbtr);
      //return;
    } else 
      DEBUG ("Can't open HsTrace!");
  } else 
    DEBUG ("Can't find HsTrace!");
  return;
}
// ====================================
// main form handler
// ------------------------------------    
static Boolean MainFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;
ListPtr         lst;
UInt16          i, j;
DmOpenRef       resDB;
MemHandle       hndl;
Char            *recent[MaxRecent];
UInt32          ftrval;
SysDBListItemType *dbptr;
DateTimeType    dt;
FieldPtr        fld;
static Boolean  drawEnable;
DmOpenRef       recdb;
static Boolean  LaunchButton=false;
static Int16    last_min;
EventType       nevt;
static Int16    alm_state;

LocalID         locid;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      FrmSetGadgetHandler (frm, i=FrmGetObjectIndex (frm, ML_button_C), (FormGadgetHandlerType*)ButtonHandler);
      FrmSetGadgetData (frm, i, (void*)(state+0L));
      FrmSetGadgetHandler (frm, i=FrmGetObjectIndex (frm, ML_button_U), (FormGadgetHandlerType*)ButtonHandler);
      FrmSetGadgetData (frm, i, (void*)(state*4+1L));
      FrmSetGadgetHandler (frm, i=FrmGetObjectIndex (frm, ML_button_D), (FormGadgetHandlerType*)ButtonHandler);
      FrmSetGadgetData (frm, i, (void*)(state*4+2L));
      FrmSetGadgetHandler (frm, i=FrmGetObjectIndex (frm, ML_button_L), (FormGadgetHandlerType*)ButtonHandler);
      FrmSetGadgetData (frm, i, (void*)(state*4+3L));
      FrmSetGadgetHandler (frm, i=FrmGetObjectIndex (frm, ML_button_R), (FormGadgetHandlerType*)ButtonHandler);
      FrmSetGadgetData (frm, i, (void*)(state*4+4L));
      FrmSetGadgetHandler (frm, i=FrmGetObjectIndex (frm, _IRDA_), (FormGadgetHandlerType*)IrGadgetHandler);
      FrmSetGadgetHandler (frm, i=FrmGetObjectIndex (frm, _ALM_), (FormGadgetHandlerType*)AlmGadgetHandler);
      if (gPmSysGadgetLibRefNum!=sysInvalidRefNum) {
        PmSysGadgetStatusGadgetTypeSet (gPmSysGadgetLibRefNum, frm, HS_BAT, pmSysGadgetStatusGadgetBattery);
        PmSysGadgetStatusGadgetTypeSet (gPmSysGadgetLibRefNum, frm, HS_GSM, pmSysGadgetStatusGadgetSignal);
        PmSysGadgetStatusGadgetTypeSet (gPmSysGadgetLibRefNum, frm, HS_BT, pmSysGadgetStatusGadgetBt);
      } else {
        CtlSetUsable (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, HS_BAT)), false);
        CtlSetUsable (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, HS_GSM)), false);
        CtlSetUsable (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, HS_BT)), false);
      }
#ifdef MAIN_ENABLE
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_enabled)), PrefGetPreference (prefLauncherAppCreator)==AppID);
#endif
      if (showRecent)
        CtlHitControl (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_recent)));
      drawEnable=true;
    case frmUpdateEvent:
      FrmDrawForm (frm);
      ShowStepLevel (frm);
      last_min=-1;
    case nilEvent:
      if (!drawEnable) break;
      // time & date
UpdateTime:
      TimSecondsToDateTime (TimGetSeconds (), &dt);
      if (dt.minute!=last_min) {
        last_min=dt.minute;
        StrPrintF (&dtb[70], "%02d:%02d", dt.hour, dt.minute);
        FrmSetTitle (frm, &dtb[70]);
        AttnIndicatorEnable (true);
        StrPrintF (dtb, "%d.%d.%d", dt.day, dt.month, dt.year); // , percent, volt/100, volt%100, (charge)?"- charge":"");
        FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, palmstate)), dtb);
        //FldRecalculateField (fld, true);
        FldDrawField (fld);
      }
      i=AlmState (-1);
      if (i!=alm_state) {
        // event pro prekresleni gadgetu
        nevt.eType=frmGadgetMiscEvent;
        nevt.data.gadgetMisc.gadgetID=_ALM_;
        nevt.data.gadgetMisc.gadgetP=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, _ALM_));
        //nevt.data.gadgetMisc.selector=;
        //nevt.data.gadgetMisc.dataP=;
        EvtAddEventToQueue (&nevt);
        alm_state=i;
      }
      break;
    case winExitEvent: // tracking of menu and other windows creation
      if (event->data.winExit.exitWindow==(WinHandle)FrmGetFormPtr (main_form)) drawEnable=0;
      break;
    case winEnterEvent: // tracking of menu and other windows creation
      if (event->data.winEnter.enterWindow==(WinHandle)FrmGetFormPtr (main_form) && event->data.winEnter.enterWindow==(WinHandle)FrmGetFirstForm ()) {
        drawEnable=true;
      }
      break;
    case menuEvent:
      handled=true;
      MenuEraseStatus (NULL);
      switch (event->data.menu.itemID) {
        case menu_tasks:
          FrmGotoForm (task_form);
          break;
        case menu_setup:
          FrmGotoForm (setup_form);
          break;
        case menu_about:
          if (!FrmCustomAlert (alert_about, build, build_date, build_time)) break;
        case menu_help:
          FrmHelp (str_about);
          break;
        case menu_reset:
          if (!FrmAlert (ReallyReset))
            SysReset ();
          break;
        case menu_reset_log:
          ShowErrorLog ();
          break;
        case menu_remove:
          // removing resources
          RemoveResource ('tICO', 1000+state);
          RemoveResource ('tICO', 2000+state);
          RemoveResource ('tAIN', 1000+state);
          RemoveResource ('tPRC', 1000+state);
          DrawButtons (frm, false);
          break;
        case menu_set:
          if (LoadDatabaseList ()) break;
          LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_apps)), appslist, appscnt);
          //LstSetSelection (lst, noListSelection);
          // pro treo650 nastavim prvni polozku
          LstSetSelection (lst, 0);
          LstSetTopItem (lst, 0);
          i=LstPopupList (lst);
          if (i==noListSelection) break;
          // protoze je seznam srovnany abecedne, musim bud DmFindDatabase, nebo pouzit ukazatel z listu...
          dbptr=(SysDBListItemType*)appslist[i];
          // nacteni ikony z vybraneho souboru a ulozeni do databaze/cache
          resDB=DmOpenDatabase (dbptr->cardNo, dbptr->dbID, dmModeReadOnly);
          if (!resDB) break; // show error message!
          // removing previous resources
          RemoveResource ('tICO', 1000+state);
          RemoveResource ('tICO', 2000+state);
          RemoveResource ('tAIN', 1000+state);
          RemoveResource ('tPRC', 1000+state);
          // loading new resources
          if ((hndl=DmGet1Resource ('tAIB', 1000))!=NULL) { // big icon
            SaveResource (MemHandleLock (hndl), MemHandleSize (hndl), 'tICO', 1000+state);
            MemHandleUnlock (hndl);
            DmReleaseResource (hndl);
          }
          if ((hndl=DmGet1Resource ('tAIB', 1001))!=NULL) { // big icon
            SaveResource (MemHandleLock (hndl), MemHandleSize (hndl), 'tICO', 2000+state);
            MemHandleUnlock (hndl);
            DmReleaseResource (hndl);
          }
          if ((hndl=DmGet1Resource ('tAIN', 1000))!=NULL) { // application icon name
            SaveResource (MemHandleLock (hndl), MemHandleSize (hndl), 'tAIN', 1000+state);
            MemHandleUnlock (hndl);
            DmReleaseResource (hndl);
          }
          SaveResource (dbptr, sizeof (SysDBListItemType), 'tPRC', 1000+state);
          DmCloseDatabase (resDB);
          DrawButtons (frm, false);
          break;
        case menu_init:
          if (!state) break;
          state=1;
          PrevLevel (frm);
          break;
	default:
	  handled=false;
	  break;
      }
      break;
    case frmGadgetHoldEvent:
      if (event->data.gadgetEnter.gadgetID!=ML_button_C && state<TopMin) {
        state*=4;
        switch (event->data.gadgetEnter.gadgetID) {
          case ML_button_U:
            state+=1;
            break;
          case ML_button_D:
            state+=2;
            break;
          case ML_button_L:
            state+=3;
            break;
          case ML_button_R:
            state+=4;
            break;
        }
        RunSelectedApp ();
        state-=1;
        state/=4;
        break;
      }
    case frmGadgetSelectEvent:
      switch (event->data.gadgetEnter.gadgetID) {
        case ML_button_C:
          RunSelectedApp ();
          break;
        case ML_button_U:
          NextLevel (frm, 1);
          break;
        case ML_button_D:
          NextLevel (frm, 2);
          break;
        case ML_button_L:
          NextLevel (frm, 3);
          break;
        case ML_button_R:
          NextLevel (frm, 4);
          break;
      }
      break;
    case keyDownEvent:
      switch (event->data.keyDown.chr) {
        case 'a':
          SysCurAppDatabase (&i, &locid);
          AttnGetAttention (i, locid, 0, NULL, kAttnLevelSubtle, 0, 60, 3);
          break;
/**
        // ruzne pokusne kody
        case '1':
          {UInt32 val;
           HsAttrGet (hsAttrKeyboardLocked, 0, &val);
           val=!val;
           HsAttrSet (hsAttrKeyboardLocked, 0, &val);
          }
          break;
        case '0':
          //{UInt16 mod; HsLightMode (false, &mod); DEBUG ("LM %X", mod); mod=hsLightModeNight; HsLightMode (true, &mod);} // toto je moc tmave! a pak je tmavy i systemovy zpusob...
          //HsLightCircumstance (true, hsLightCircumstanceUserNotLooking);
          DEBUG ("CC %X", HsCurrentLightCircumstance ());
	  break;
        case '1':
          //{UInt16 mod; HsLightMode (false, &mod); DEBUG ("LM %X", mod); mod=hsLightModeNormal; HsLightMode (true, &mod);}
          HsLightCircumstance (false, hsLightCircumstanceUserNotLooking);
          break;
        case 'l':
          {
            SysNotifyParamType srmNotify = { MLnotify, AppID, reqKeyguard, NULL, false, 0 };
            //SysNotifyBroadcast (&srmNotify); //sizeof (srmNotifyDetails)+dw);
            NotifyProc (&srmNotify);
          }
          break;
        // rucni ovladani BT, Phone, Alarm...
        case 'P':
          // zmena stavu telefonu: ON <=> OFF
          HsGetPhoneLibrary (&i);
          PhnLibSetModulePower (i, (PhnLibModulePowered (i)!=phnPowerOn)?1:0);
          break;
        case 'B':
          // zmena stavu BT: ON <=> OFF
          // zatim se mi nepodarilo zjistit, jak to udelat...
          break;
        case 'A':
          // zmena stavu Alarm: LOUD <=> SILENT
          //HsAttrGet (hsAttrRingSwitch, 0, &ftrval);
          //ftrval=(ftrval==hsAttrRingSwitchMute)?hsAttrRingSwitchLoud:hsAttrRingSwitchMute;
          //HsAttrSet (hsAttrRingSwitch, 0, &ftrval);
          {
            const SysNotifyParamType alof={'hROf', AppID, NULL, NULL, false, 0};
            DEBUG ("AlmOff...?");
            SysNotifyBroadcast (&alof);
          }
          break;
**/
        case vchrLateWakeup:
          last_min=-1;
          goto UpdateTime;
        case '\x08': // prev level
          PrevLevel (frm);
          break;
        case vchrPageUp:
          NextLevel (frm, 1);
          break;
        case vchrPageDown:
          NextLevel (frm, 2);
          break;
        case '<':
          NextLevel (frm, 3);
          break;
        case '>':
          NextLevel (frm, 4);
          break;
        case '\x0A':
          RunSelectedApp ();
          break;
        case vchrRockerUp:
          NextLevel (frm, 1);
          break;
        case vchrRockerDown:
          NextLevel (frm, 2);
          break;
        case vchrRockerLeft:
          NextLevel (frm, 3);
          break;
        case vchrRockerRight:
          NextLevel (frm, 4);
          break;
        case vchrRockerCenter:
          RunSelectedApp ();
          break;
        case vchrNavChange:
          handled=true;
          switch (event->data.keyDown.keyCode&(navBitsAll|navChangeSelect)) {
            case navBitUp: // 1
              NextLevel (frm, 1);
              break;
            case navBitDown: // 2
              NextLevel (frm, 2);
              break;
            case navBitLeft: // 3
              NextLevel (frm, 3);
              break;
            case navBitRight: // 4
              NextLevel (frm, 4);
              break;
            case navBitSelect|navChangeSelect: // SELECT press
              flags|=SelPressed;
              break;
            case navBitSelect: // SELECT holding
              if (flags&SelPressed) {
                CtlHitControl (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_recent)));
                flags&=~SelPressed;
              }
              handled=true;
              break;
            case navChangeSelect: // SELECT releasing
              if (flags&SelPressed)
                RunSelectedApp ();
//              else
//                CtlHitControl (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_recent)));
              break;
          }
          //DrawButtons (frm, true);
        case vchrLaunch:
          if (!LaunchButton) {
            EventType evt;
            evt.eType=ctlSelectEvent;
            evt.data.ctlSelect.controlID=ML_recent;
            EvtAddEventToQueue (&evt);
            LaunchButton=true;
            break;
          }
          LaunchButton=false;
          break;
	default:
	  break;
      }
      break;
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
#ifdef MAIN_ENABLE
        case ML_enabled:
          Prefs.bits &= ~MULTILAUNCHER_ON;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_enabled)))) Prefs.bits|=MULTILAUNCHER_ON;
          EnableMLauncher (Prefs.bits);
          break;
#endif
        case ML_recent:
          recdb=DmOpenDatabaseByTypeCreator (RecentType, AppID, dmModeReadWrite);
          if (!recdb) break;
          //j=MaxRecent;
          j=0; // pro treo650
          for (i=0; i<DmNumRecords (recdb) && i<=MaxRecent; i++) {
            hndl=DmQueryRecord (recdb, i);
            if (hndl==NULL) continue;
            //recent[j-1]=MemHandleLock (hndl);
            recent[j]=MemHandleLock (hndl); // pro treo650
            MemHandleUnlock (hndl);
            // I hope that the pointer remains valid for the time the listbox will be visible...
            //if (StrCompare (recent[j-1], "MLaunch"))
            //  j--;
            if (StrCompare (recent[j], "MLaunch"))
              j++;
          }
          DmCloseDatabase (recdb);
          //i=MaxRecent-j;
          //if (!i) break; // alert No Recent Apps saved!
          if (!j) break;
          //LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_apps)), &recent[j], i);
          //LstSetSelection (lst, noListSelection);
          // pro treo650
          LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list_apps)), recent, j);
          LstSetSelection (lst, 1);
          LstSetTopItem (lst, 0);
          i=LstPopupList (lst);
          if (i==noListSelection) break;
          LaunchButton=false;
          //i+=j;
          // switch to selected app
          SysCurAppDatabase (&j, &ftrval);
          ftrval=DmFindDatabase (j, recent[i]);
          if (!ftrval) break;
          SysUIAppSwitch (j, ftrval, sysAppLaunchCmdNormalLaunch, NULL);
          break;
        case ML_back:
          PrevLevel (frm);
          break;
	default:
	  break;
      }
      break;
    default:
      break;
  }
  return handled;
}
// ====================================
// task support functions
// ------------------------------------    
// number scan function
// ------------------------------------
static UInt16 ScanNum (Char *str, Int32 *val) {
Boolean neg=false;
UInt16 pos;
  pos=0;
  if (str[pos]=='-') {pos++; neg=true;}
  if (str[pos]=='0' && str[pos+1]=='x') { // HEX
    pos+=2;
    *val=0;
    while ((str[pos]>='0' && str[pos]<='9') || ((str[pos]&0xDF)>='A' && (str[pos]&0xDF)<='F')) {
      *val<<=4;
      *val|=(str[pos]<='9')?(str[pos]-'0'):((str[pos]&0xDF)-'A'+0xA);
      pos++;
    }
  } else
  if (*str=='0') { // OCT
    pos++;
    *val=0;
    while (str[pos]>='0' && str[pos]<='7') {
      *val<<=3;
      *val|=str[pos]-'0';
      pos++;
    }                
  } else
  if (str[pos]>'0' && str[pos]<='9') { //DEC
    *val=0;
    while (str[pos]>='0' && str[pos]<='9') {
      *val*=10;
      *val+=str[pos]-'0';
      pos++;
    }            
  } else
    return 0;
  if (neg) *val=-*val;
  return pos;
}
// ------------------------------------    
// resource string table search function
// ------------------------------------
// tSTL je ulozeny: "string title", size, "string0", "string1", ...
// SysStringByIndex vraci "string title"+"stringN"!
static Char *GetEventString (UInt16 type) {
UInt16 cnt;
UInt8 *ptr;
UInt16 i;
UInt32 val;

  ptr=evtstr;
  ptr+=StrLen (ptr)+1;
  cnt=evtcnt; //(ptr[0]<<8)|ptr[1];
  ptr+=2;
  while (cnt) {
    // hledam ':'
    for (i=0; ptr[i] && ptr[i]!=':'; i++);
    if (ptr[i]==':') {
      while (i && ptr[i-1]!=' ') i--;
      // nactu cislo
      ScanNum (&ptr[i], &val);
      if (val==type) break;
    }
    // dalsi
    ptr+=StrLen (ptr)+1;
    cnt--;
  }
  return cnt?ptr:NULL;
}
// ------------------------------------    
// event formatter
// ------------------------------------
// vytvoreni popisu podle zadanych flagu
#define EVT_NAME        0x0001
#define EVT_DATA        0x0002
#define EVT_DATA_NAME   0x0004
#define EVT_DATA_LEN    0x0008
#define EVT_GENERIC     0x1000
static Char *CreateDescription (EventType *event, Char *str, UInt16 type) {
Char *desc;
Int16 i, pos, j;
UInt32 val;
UInt8 *data, flags;

  pos=0;
  // event name
  desc=GetEventString (event->eType);
  if (!desc) {
    desc=events[evtcnt-2];
    while (*desc) desc++;
    desc++;
    type |= EVT_GENERIC;
  }
  if (type&EVT_NAME) {
    for (i=0; desc[i] && desc[i]!=':'; i++);
    if (desc[i]==':') i++;
    if (type&EVT_GENERIC) {
      //pos+=StrPrintF (&str[pos], "0x%04X%c", event->eType, type?'\n':' ');
      pos+=StrPrintF (&str[pos], "#0x%04X ", event->eType);
    } else {
      pos+=StrPrintF (&str[pos], "%s ", &desc[i]);
    }
  }
  // common event information
  /**if (type) {
    pos+=StrPrintF (&str[pos], "pen %s at [%d,%d] rep %d\n", 
                    event->penDown?"down":"up", 
                    event->screenX), 
                    event->screenY), 
                    event->tapCount);
  }**/
  // special/partial event information
  j=0;
  data=(UInt8*)&event->data;
  do {
    while (desc[j]>0 && desc[j]<=' ') j++;
    // zapamatovani hexa pozadavku
    flags=(desc[j]=='0' && desc[j+1]=='x')?0x01:0x00;
    j+=ScanNum (&desc[j], &val);
    if (desc[j]==':') break;
    // zapamatovani a preskoceni prefixu
    if (desc[j]=='!') {j++; flags|=0x02;}
    if (desc[j]=='*') flags|=0x01;
    if (desc[j]=='_') j++;
    // nakopirovani nazvu
    while (desc[j] && (desc[j]>' ' || desc[j]<0)) {
      if (type&EVT_DATA_NAME) str[pos++]=desc[j];
      j++;
    }
    if (type&EVT_DATA_NAME && val!=-1)
      str[pos++]='=';
    if (type&EVT_DATA_LEN && val<100)
      pos+=StrPrintF (&str[pos], "%d:", (UInt16)val);
    // zobrazeni hodnoty
    if (val==-1) {
      //pos+=StrPrintF (&str[pos], "[%d,%d,%d,%d] ", event->penDown, event->screenX, event->screenY, event->tapCount);
      pos+=StrPrintF (&str[pos], type&EVT_DATA_NAME?"[penDown=%d,tapCount=%d,screenX=%d,screenY=%d] ":"[%d,%d,%d,%d] ", event->penDown, event->tapCount, event->screenX, event->screenY);
    } else
    if (val==1) {
      pos+=StrPrintF (&str[pos], flags&0x01?"0x%02X":"%u", *data);
      data++;
    } else
    if (val==2) {
      pos+=StrPrintF (&str[pos], flags&0x01?"0x%04X":"%u", *((UInt16*)data));
      val=*((UInt16*)data); 
      data+=2;
    } else
    if (val==4) {
      pos+=StrPrintF (&str[pos], flags&0x01?"0x%08lX":"%lu", *((UInt32*)data));
      data+=4;
    }
    str[pos++]=' ';
  } while (desc[j]);
  // smazani zaverecnych mezer
  while (pos>0) {
    if (str[pos-1]!=' ') break;
    pos--;
  }
  str[pos]=0;

  return str;
}
// ------------------------------------    
// parsing text event string
// ------------------------------------    
enum {PFLG_normal, PFLG_common, PFLG_event};
static Int16 ParseEvent (EventType *evt, Char *s) {
UInt32          val;
UInt8           pflg, pidx, len;
Int16           res;

  pflg=PFLG_normal; pidx=0;
  len=1;
  while (*s) {
    while ((*s>0 && *s<=' ') || *s==',') s++;
    if (*s=='[') {
      // zacatek zpracovani spolecneho bloku dat
      pflg=PFLG_common;
      pidx=0;
      s++;
    } else
    if (*s==']') {
      // konec zpracovani spolecneho bloku dat
      pflg=PFLG_normal;
      pidx=0;
      s++;
    } else
    if (*s=='#') {
      // zpracovani cisla eventu
      s++;
      pflg=PFLG_event;
    } else {
      // obecne nacteni cisla
      //DEBUG ("parsing from %s", s);
      res=ScanNum (s, &val);
      if (!res) {DEBUG ("Error from %s", s); res=1;}
      s+=res;
      if (pflg==PFLG_event) {
        evt->eType=val;
      } else
      if (pflg==PFLG_common) {
        if (pidx==0) {
          evt->penDown=val;
        } else
        if (pidx==1) {
          evt->tapCount=val;
        } else
        if (pidx==2) {
          evt->screenX=val;
        } else
        if (pidx==3) {
          evt->screenY=val;
        }
        pidx++;
      } else
      if (pflg==PFLG_normal) {
        if (*s==':') {
          len=val;
          s++;
        } else {
          if (pidx+len<=sizeof (evt->data)) {
            if (len==1) {
              *(((UInt8*)&evt->data)+pidx)=val;
            } else
            if (len==2) {            
              *(UInt16*)(((UInt8*)&evt->data)+pidx)=val;
            } else
            if (len==4) {            
              *(UInt32*)(((UInt8*)&evt->data)+pidx)=val;
            }
          }
          pidx+=len;
          len=1;
        }
      }
    }
  }
  return 0;
}
// ------------------------------------    
// filling step form
// ------------------------------------    
#define KEEP_DELAY      0x01
static void FillStepForm (FormPtr frm, stepType *step, UInt8 flags) {
// data se berou z globalni promenne???
//void FillStepForm (FormPtr frm) {
Int16           i;
Char            str[128], *s;
void            *gptr;
  // step delay
  if (!(flags&KEEP_DELAY)) {
    i=StrPrintF (str, "%d", step->delay);
    FldDelete (gptr=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, step_time)), 0, 100);
    FldInsert (gptr, str, i);
  }
  // action
  if (step->action<STEP_end) {
    LstSetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, action_list)), step->action);
    CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, action_trig)), actions[step->action]);
  }
  // data
  switch (step->action) {
    // text actions
    case STEP_launch:
    case STEP_text:
      FrmHideObject (frm, FrmGetObjectIndex (frm, onoff_check));
      FrmHideObject (frm, FrmGetObjectIndex (frm, event_trig));
      FldDelete (gptr=FrmGetObjectPtr (frm, i=FrmGetObjectIndex (frm, step_data)), 0, 100);
      FldInsert (gptr, step->data.str, StrLen (step->data.str));
      FrmShowObject (frm, i);
      break;
    // on/off actions
    case STEP_phone:
    case STEP_BT:
    case STEP_alarm:
    case STEP_keyguard:
      FrmHideObject (frm, FrmGetObjectIndex (frm, event_trig));
      FrmHideObject (frm, FrmGetObjectIndex (frm, step_data));
      CtlSetValue (FrmGetObjectPtr (frm, i=FrmGetObjectIndex (frm, onoff_check)), step->data.val);
      FrmShowObject (frm, i);
      break;
    // other...
    case STEP_event:
      FrmHideObject (frm, FrmGetObjectIndex (frm, onoff_check));
      s=GetEventString (step->data.event.eType);
      if (s) {
        while (*s && *s!=':') s++;
        if (*s==':') s++;
        i=0;
      } else {
        s=events[evtcnt-1];
        i=EVT_NAME;
      }
      CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, event_trig)), s);
      CreateDescription (&step->data.event, str, EVT_DATA | EVT_DATA_LEN | i);
      FldDelete (gptr=FrmGetObjectPtr (frm, i=FrmGetObjectIndex (frm, step_data)), 0, 100);
      FldInsert (gptr, str, StrLen (str));
      FrmShowObject (frm, i);
      FrmShowObject (frm, FrmGetObjectIndex (frm, event_trig));
      break;
  }
}
// ------------------------------------    
// step form handler
// ------------------------------------    
static Boolean StepFormHandler (EventType *event) {
Boolean handled=false;
FormPtr frm=FrmGetActiveForm ();
Char *s;
UInt32 val;

  switch (event->eType) {
    case frmOpenEvent:
      break;
    case frmUpdateEvent:
      break;
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
        case step_help:
          handled=true;
          if (sval.action==STEP_event) {
            Char str[180];
            CreateDescription (&sval.data.event, str, EVT_DATA | EVT_DATA_NAME);
            DEBUG ("%s", str);
          } else
            FrmHelp (step_help);
          break;
      }
      break;
    case popSelectEvent:
      switch (event->data.popSelect.listID) {
        case action_list:
          sval.action=event->data.popSelect.selection;
          FillStepForm (frm, &sval, KEEP_DELAY);
          break;
        case event_list:
          s=events[event->data.popSelect.selection];
          do {
            s--;
          } while (*s && *s!=' ');
          if (!*s || *s==' ') s++;
          ScanNum (s, &val);
          sval.data.event.eType=val;
          FillStepForm (frm, &sval, KEEP_DELAY);
          break;
      }
      break;
    default:
      break;
  }
  return handled;
}
// ------------------------------------    
// step edit dialog
// ------------------------------------    
static Int16 EditTaskStep (stepType *step) {
FormPtr         difrm;
Int16           i;
MemHandle       hndl;
UInt32          val;
//stepType        lstp;
Char            *s;

//  frm=FrmGetActiveForm ();
  // before opening edit window release focus
//  i=FrmGetFocus (frm);
//  if (i!=noFocus)
//    FldReleaseFocus (FrmGetObjectPtr (frm, i));
  // opening edit window
  difrm=FrmInitForm (task_step);
  LstSetListChoices (FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, action_list)), actions, STEP_end);
  LstSetListChoices (FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, event_list)), events, evtcnt);
  // preparing data
  FillStepForm (difrm, step, 0);
  FrmSetEventHandler (difrm, (FormEventHandlerPtr) StepFormHandler);
  FrmDrawForm (difrm);
//  FrmSetFocus (difrm, FrmGetObjectIndex (difrm, edit_value));
  i=FrmDoDialog (difrm);
  if (i==step_OK) {
    // parsing data
    // step delay
    hndl=FldGetTextHandle (FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, step_time)));
    if (!hndl) step->delay=0;
    else {
      ScanNum (MemHandleLock (hndl), &val);
      MemHandleUnlock (hndl);
      step->delay=val;
    }
    // action
    step->action=LstGetSelection (FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, action_list)));
    // action data
    switch (step->action) {
      // text actions
      case STEP_launch:
      case STEP_text:
        hndl=FldGetTextHandle (FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, step_data)));
        if (!hndl) {
          *step->data.str=0;
          break;
        }          
        StrNCopy (step->data.str, MemHandleLock (hndl), 31);
        MemHandleUnlock (hndl);
        break;
      // on/off actions
      case STEP_phone:
      case STEP_BT:
      case STEP_alarm:
      case STEP_keyguard:
        step->data.val=CtlGetValue (FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, onoff_check)));
        break;
      // other...
      case STEP_event:
        hndl=FldGetTextHandle (FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, step_data)));
        if (!hndl) break;
        s=MemHandleLock (hndl);
        ParseEvent (&step->data.event, s);
        MemHandleUnlock (hndl);
        break;
    }
  }
  FrmDeleteForm (difrm);
  return i;
}
// ------------------------------------
// UI globals reload for TASKs
// ------------------------------------
static Err ReloadTaskList (FormPtr frm, UInt16 tasknum) {
UInt16          i, j;
MemHandle       hndl;
taskType        *tptr;
ListPtr         lst;

  taskcnt=0;
  j=DmNumRecords (taskDB);
  if (j>MaxTasks) j=MaxTasks;
  for (i=0; i<j; i++) {
    hndl=DmQueryRecord (taskDB, i);
    if (hndl==NULL) continue;
    tptr=MemHandleLock (hndl);
    tasklist[taskcnt++]=tptr->name;
    MemHandleUnlock (hndl);
  }
  LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, task_list)), tasklist, taskcnt);
  LstSetSelection (lst, (tasknum>=j)?noListSelection:tasknum);
  return 0;
}
// ------------------------------------
// drawing STEP list item
// ------------------------------------
/**
static void DrawStepItem (Int16 itemNum, RectangleType *bounds, Char **itemsText) {
  WinDrawChars (itemsText[itemNum], StrLen (itemsText[itemNum]), bounds->topLeft.x, bounds->topLeft.y);
}
**/
// ------------------------------------
// UI globals reload for STEPs
// ------------------------------------
static Err ReloadStepList (FormPtr frm, UInt16 task, UInt16 step) {
UInt16          cnt, pos;
taskType        *tptr;
MemHandle       hndl;
ListPtr         lst;

  hndl=DmQueryRecord (taskDB, task);
  if (hndl==NULL) return 1;
  cnt=(MemHandleSize (hndl)-sizeof (taskType))/sizeof (stepType);
  tptr=MemHandleLock (hndl);
  for (stepcnt=0; stepcnt<cnt && stepcnt<MaxSteps; stepcnt++) {
    // vytvoreni popisu kroku
    pos = StrPrintF (steplist[stepcnt], "+%ds ", tptr->step[stepcnt].delay);
    if (tptr->step[stepcnt].action>=STEP_end) {
      pos += StrPrintF (steplist[stepcnt]+pos, "unknown (%d)", tptr->step[stepcnt].action);
    } else {
      pos += StrPrintF (steplist[stepcnt]+pos, "%s ", actions[tptr->step[stepcnt].action]);
      switch (tptr->step[stepcnt].action) {
        // text actions
        case STEP_launch:
        case STEP_text:
          steplist[stepcnt][pos++]='"';
          StrCopy (steplist[stepcnt]+pos, tptr->step[stepcnt].data.str);
          pos+=StrLen (tptr->step[stepcnt].data.str);
          steplist[stepcnt][pos++]='"';
          steplist[stepcnt][pos]=0;
          break;
        // on/off actions
        case STEP_phone:
        case STEP_BT:
        case STEP_alarm:
        case STEP_keyguard:
          pos += StrPrintF (steplist[stepcnt]+pos, "%s", tptr->step[stepcnt].data.val?"On":"Off");
          break;
        // other...
        case STEP_event:
          CreateDescription (&tptr->step[stepcnt].data.event, steplist[stepcnt]+pos, EVT_NAME | EVT_DATA);
          break;
      }
    }
  }
  MemHandleUnlock (hndl);
  LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, step_list)), steplist, stepcnt);
  LstSetSelection (lst, step);
  LstDrawList (lst);
  return 0;
}
// ------------------------------------
// TASK drawing
// ------------------------------------
const UInt16    ctl_num[8]={ScheduleDaySun, ScheduleDayMon, ScheduleDayTue, ScheduleDayWed, ScheduleDayThu, ScheduleDayFri, ScheduleDaySat, task_on};
static void ShowTask (FormPtr frm, UInt16 task_idx, UInt16 step_idx) {
MemHandle       hndl;
void            *ptr;
UInt16          i;

  MemSet (&tval, sizeof (taskType), 0);
  hndl=NULL;
  if (task_idx<DmNumRecords (taskDB)) {
    hndl=DmQueryRecord (taskDB, task_idx);
    if (hndl) {
      MemMove (&tval, MemHandleLock (hndl), sizeof (taskType));
      MemHandleUnlock (hndl);
    }
  }
  // jmeno TASKu
  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, task_trig)), (hndl)?tasklist[task_idx]:"");
  // typ
  ptr=LstGetSelectionText (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, type_list)), tval.condition);
  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, type_trig)), (hndl && ptr)?ptr:"type");
  // cas spusteni
  StrPrintF (ttype, "%02d:%02d", (UInt16)((tval.time/3600)%24), (UInt16)((tval.time/60)%60));
  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, time_trig)), ttype);
  // dny spusteni + Enable/disable
  for (i=0; i<8; i++) {
    CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ctl_num[i])), (tval.weekdays&(1<<i))!=0);
  }
  FrmDrawForm (frm);
  ReloadStepList (frm, task_idx, step_idx);
}
// ------------------------------------
// TASK name edit
// ------------------------------------
static Int16 EditTaskName (Char *name) {
//FormPtr         frm;
FormPtr         difrm;
Int16           i;
MemHandle       hndl;

//  frm=FrmGetActiveForm ();
  // before opening edit window release focus
//  i=FrmGetFocus (frm);
//  if (i!=noFocus)
//    FldReleaseFocus (FrmGetObjectPtr (frm, i));
  // opening edit window
  difrm=FrmInitForm (task_name);
  FrmDrawForm (difrm);
  if (*name)
    FldInsert (FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, task_name)), name, StrLen (name));
//  FrmSetFocus (difrm, FrmGetObjectIndex (difrm, edit_value));
  i=FrmDoDialog (difrm);
  if (i==step_OK) {
    hndl=FldGetTextHandle (FrmGetObjectPtr (difrm, FrmGetObjectIndex (difrm, task_name)));
    if (hndl) {
      StrCopy (name, MemHandleLock (hndl));
      MemHandleUnlock (hndl);
    } else
      *name=0;
  }
  FrmDeleteForm (difrm);
  return i;
}
// ------------------------------------    
// zapis pozadovane casti zaznamu
// ------------------------------------    
static Int16 WriteRecord (UInt16 index, UInt32 offs, void *ptr, UInt32 len) {
MemHandle       hndl;

  hndl=DmGetRecord (taskDB, index);
  if (hndl==NULL) return -1;
  DmWrite (MemHandleLock (hndl), offs, ptr, len);
  MemHandleUnlock (hndl);
  DmReleaseRecord (taskDB, index, true);
  return 0;
}
// ====================================
// TASK form handler
// ------------------------------------    
static Boolean TaskFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;
ListPtr         lst;
MemHandle       hndl;
taskType        *tptr;
UInt16          i, j;
const taskType  def_task = {"new task", 12*60*60L, 0x7F, 0};
Char            tname[TASKNAMELEN];
UInt32          size;
Int16           sign;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, step_list)), NULL, 0);
//      LstSetDrawFunction (lst, (ListDrawDataFuncPtr)DrawStepItem);
      //if (DmNumRecords (taskDB)) prefs.tasknum=0;
      //ShowTask (frm, prefs.tasknum, prefs.stepnum);
    case frmUpdateEvent:
      ReloadTaskList (frm, Prefs.tasknum);
      ShowTask (frm, Prefs.tasknum, Prefs.stepnum);
      //FrmDrawForm (frm);
      break;
    case menuEvent:
      handled=true;
      MenuEraseStatus (NULL);
      switch (event->data.menu.itemID) {
        case menu_apps:
          FrmGotoForm (main_form);
          break;
        case menu_new: // new task
          // nejdriv se musi zadat jmeno
          *tname=0;
          i=EditTaskName (tname);
          if (i!=step_OK || !*tname) break;
          // creating new task record with default values:
          // "new task", at 12:00
          i=dmMaxRecordIndex;
          hndl=DmNewRecord (taskDB, &i, sizeof (taskType));
          if (!hndl) break;
          MemMove (&tval, &def_task, sizeof (def_task));
          MemMove (tval.name, tname, TASKNAMELEN);
          DmWrite (MemHandleLock (hndl), 0, &tval, sizeof (taskType));
          MemHandleUnlock (hndl);
          DmReleaseRecord (taskDB, Prefs.tasknum=i, true);
          Prefs.stepnum=noListSelection; //0;
          // nova data se musi take zobrazit!!!
          ReloadTaskList (frm, Prefs.tasknum);
          ShowTask (frm, Prefs.tasknum, Prefs.stepnum);
          break;
        case menu_delete: // delete task
          if (Prefs.tasknum<(i=DmNumRecords (taskDB))) {
            DmRemoveRecord (taskDB, Prefs.tasknum);
            if (Prefs.tasknum>=i)
              Prefs.tasknum=(i)?i-1:0;
            Prefs.stepnum=noListSelection;
            ReloadTaskList (frm, Prefs.tasknum);
            ShowTask (frm, Prefs.tasknum, Prefs.stepnum);
          }
          break;
        case menu_rename: // rename task
          if (Prefs.tasknum>=DmNumRecords (taskDB)) break;
          StrCopy (tname, tval.name);
          i=EditTaskName (tname);
          if (i!=step_OK) break;
          if (!StrCompare (tval.name, tname)) break;
          MemMove (tval.name, tname, TASKNAMELEN);
          WriteRecord (Prefs.tasknum, 0, &tval, sizeof (taskType));
          ReloadTaskList (frm, Prefs.tasknum);
          ShowTask (frm, Prefs.tasknum, Prefs.stepnum);
          break;
        case menu_runnow:
          if (Prefs.tasknum>=DmNumRecords (taskDB)) break;
          SetTaskAlarm (TimGetSeconds ()+5, Prefs.tasknum);
          break;
	case step_add: // add step
	  MemSet (&sval, sizeof (stepType), 0);
	  if (EditTaskStep (&sval)==step_OK) {
	    // pridani zaznamu do struktury
	    hndl=DmQueryRecord (taskDB, Prefs.tasknum);
	    if (!hndl) break;
	    size=MemHandleSize (hndl);
	    // zatim se pridava jen na konec
	    Prefs.stepnum=((size-sizeof (taskType))/sizeof (stepType));
	    hndl=DmResizeRecord (taskDB, Prefs.tasknum, size+sizeof (stepType));
	    if (!hndl) break;
	    WriteRecord (Prefs.tasknum, sizeof (taskType)+Prefs.stepnum*sizeof (stepType), &sval, sizeof (stepType));
	    ReloadStepList (frm, Prefs.tasknum, Prefs.stepnum);
	  }
	  break;
	case step_edit: // edit step
	  // nejdriv musim zobrazit data aktualniho/vybraneho kroku
	  // coz by bylo predanim ukazatele na strukturu kroku
	  if (Prefs.tasknum>=DmNumRecords (taskDB)) break;
	  hndl=DmQueryRecord (taskDB, Prefs.tasknum);
	  if (!hndl) break;
	  if (Prefs.stepnum>=((MemHandleSize (hndl)-sizeof (taskType))/sizeof (stepType))) break;
	  tptr=MemHandleLock (hndl);
	  MemMove (&sval, &tptr->step[Prefs.stepnum], sizeof (stepType));
	  MemHandleUnlock (hndl);
	  if (EditTaskStep (&sval)==step_OK) {
	    WriteRecord (Prefs.tasknum, sizeof (taskType)+Prefs.stepnum*sizeof (stepType), &sval, sizeof (stepType));
	    ReloadStepList (frm, Prefs.tasknum, Prefs.stepnum);
	  }
	  break;
	case step_delete: // delete step
	  hndl=DmQueryRecord (taskDB, Prefs.tasknum);
	  if (!hndl) break;
	  size=MemHandleSize (hndl);
	  i=(size-sizeof (taskType))/sizeof (stepType);
	  if (Prefs.stepnum>=i) break;
	  if (!i) break;
          if (Prefs.stepnum+1<i) {
	    // presunuti casti zaznamu
	    WriteRecord (Prefs.tasknum, sizeof (taskType)+Prefs.stepnum*sizeof (stepType), &(((taskType*)MemHandleLock (hndl))->step[Prefs.stepnum+1]), sizeof (stepType)*(i-Prefs.stepnum-1));
	    MemHandleUnlock (hndl);
	  }
          hndl=DmResizeRecord (taskDB, Prefs.tasknum, size-sizeof (stepType));
          ReloadStepList (frm, Prefs.tasknum, Prefs.stepnum);
	  break;
	case step_up:
	case step_down:
	  hndl=DmQueryRecord (taskDB, Prefs.tasknum);
	  if (!hndl) break;
	  size=MemHandleSize (hndl);
	  i=(size-sizeof (taskType))/sizeof (stepType);
	  if (Prefs.stepnum>=i) break;
	  sign=1;
	  if (event->data.menu.itemID==step_down && Prefs.stepnum+1==i) break;
	  if (event->data.menu.itemID==step_up) {
            if (!Prefs.stepnum) break;
            sign=-1;
          }
	  // ulozim aktualni do globalni promenne
	  MemMove (&sval, &(((taskType*)MemHandleLock (hndl))->step[Prefs.stepnum]), sizeof (stepType));
	  MemHandleUnlock (hndl);
	  // presunu nasledujici/predchozi zaznam
          WriteRecord (Prefs.tasknum, sizeof (taskType)+Prefs.stepnum*sizeof (stepType), &(((taskType*)MemHandleLock (hndl))->step[Prefs.stepnum+sign]), sizeof (stepType));
          MemHandleUnlock (hndl);
	  // zapisu ulozena data
          WriteRecord (Prefs.tasknum, sizeof (taskType)+(Prefs.stepnum+sign)*sizeof (stepType), &sval, sizeof (stepType));
          ReloadStepList (frm, Prefs.tasknum, Prefs.stepnum);
          // vyberu novy zaznam
          Prefs.stepnum+=sign;
          LstSetSelection (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, step_list)), Prefs.stepnum);
	  break;
        default:
          handled=false;
          break;
      }
      break;
    case lstSelectEvent:
      switch (event->data.lstSelect.listID) {
        case step_list:
          Prefs.stepnum=event->data.lstSelect.selection;
          break;
        default:
          break;
      }
      break;
    case popSelectEvent:
      switch (event->data.popSelect.listID) {
        case task_list:
          // loading selected task's steps to list
          Prefs.stepnum=noListSelection;
          ShowTask (frm, Prefs.tasknum=event->data.popSelect.selection, Prefs.stepnum);
          //ReloadStepList (frm, Prefs.tasknum, Prefs.stepnum);
          break;
        case type_list:
          tval.condition=event->data.popSelect.selection;
          WriteRecord (Prefs.tasknum, 0, &tval, sizeof (taskType));
          break;
      }
      break;
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
        case time_trig:
          if (Prefs.tasknum>=DmNumRecords (taskDB)) break;
          i=(tval.time/3600)%24; j=(tval.time/60)%60;
          if (!SelectOneTime (&i, &j, "Task start time")) break;
          tval.time=(i*60L+j)*60;
          if (!tval.time) tval.time=6;
          WriteRecord (Prefs.tasknum, 0, &tval, sizeof (taskType));
          ShowTask (frm, Prefs.tasknum, Prefs.stepnum);
          break;
/**
        case task_trig:
          ReloadTaskList (frm, Prefs.tasknum);
          break;
**/
        case task_on:
        case ScheduleDaySun:
        case ScheduleDayMon:
        case ScheduleDayTue:
        case ScheduleDayWed:
        case ScheduleDayThu:
        case ScheduleDayFri:
        case ScheduleDaySat:
          if (Prefs.tasknum>=DmNumRecords (taskDB)) break;
          for (i=0; i<8; i++) if (event->data.ctlSelect.controlID==ctl_num[i]) break;
          if (i>7) break;
          tval.weekdays ^= (1<<i);
          WriteRecord (Prefs.tasknum, 0, &tval, sizeof (taskType));
          if (event->data.ctlSelect.controlID!=task_on)
            CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ctl_num[i])), tval.weekdays&(1<<i));
          break;
        default:
          break;
      }
      break;
    case keyDownEvent:
      switch (event->data.keyDown.chr) {
        case vchrLaunch:
          if (!FtrGet (AppID, FTR_BITS, &size))
            if (size & MULTILAUNCHER_ON) {
              FrmGotoForm (main_form);
              handled=true;
            }
          break;
      }
      break;
    default:
      break;
  }
  return handled;
}
// ====================================
// preferences/setup form handler
// ------------------------------------    
static Boolean SetupFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;

  frm=FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_enabled)), PrefGetPreference (prefLauncherAppCreator)==AppID);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_contrast)), (Prefs.bits & CONTRAST_KEYS) != 0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_selection)), (Prefs.bits & SELECTION_KEYS) != 0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_cmdbar)), (Prefs.bits & CMD_BAR_KEY) != 0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_graffiti)), (Prefs.bits & GRAFFITI_CONTROL) != 0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_TEpatch)), (Prefs.bits & GRAFFITI_PATCH) != 0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_scheduler)), (Prefs.bits & SCHEDULER_ON) != 0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_keyguard)), (Prefs.bits & KEYGUARD_ON) != 0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_alarmlog)), (Prefs.bits & ALARMLOG_ON) != 0);
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_debuglog)), (Prefs.bits & DEBUGLOG_ON) != 0);
    case frmUpdateEvent:
      FrmDrawForm (frm);
      break;
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
        case setup_OK:
          Prefs.bits &= 0xFFFF0000;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_enabled)))) Prefs.bits|=MULTILAUNCHER_ON;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_contrast)))) Prefs.bits|=CONTRAST_KEYS;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_selection)))) Prefs.bits|=SELECTION_KEYS;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_cmdbar)))) Prefs.bits|=CMD_BAR_KEY;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_graffiti)))) Prefs.bits|=GRAFFITI_CONTROL;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_TEpatch)))) Prefs.bits|=GRAFFITI_PATCH;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_scheduler)))) Prefs.bits|=SCHEDULER_ON;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_keyguard)))) Prefs.bits|=KEYGUARD_ON;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_alarmlog)))) Prefs.bits|=ALARMLOG_ON;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, ML_debuglog)))) Prefs.bits|=DEBUGLOG_ON;
          EnableMLauncher (Prefs.bits);
          FrmGotoForm (main_form);
          break;
      }
      break;
    default:
      break;
  }
  return handled;
}
// ====================================
// basic application functions
// ------------------------------------    
// startup setup
// ------------------------------------
static Err StartApplication(void) {
UInt16          i;
UInt16          card;
LocalID         locid;
DmOpenRef       recdb;
Err             err;
MemHandle       hndl;
UInt8           *ptr;

  // initializing variables
  appslist=NULL;
  apps_ptr=NULL;
  appscnt=0;
  cacheDB=0;
  
  state=0;
  flags=0;
  
  tasklist=NULL;
  steplist=NULL;
  taskcnt=stepcnt=0;
  taskDB=0;

  showRecent=false;
  
  gPmSysGadgetLibRefNum=sysInvalidRefNum;

  // initializing task variables
  tasklist=NULL;
  steplist=NULL;
  actions=NULL;
  taskcnt=stepcnt=evtcnt=0;
  events=NULL;
  evtstr=NULL;
  taskDB=0;
  
  // loading preferences
  card=0;
  i=PrefGetAppPreferences (AppID, PREF_APP, NULL, &card, true);
  if (i!=noPreferenceFound) {
    if (card > sizeof (Prefs)) card=sizeof (Prefs);
    PrefGetAppPreferences (AppID, PREF_APP, &Prefs, &card, true);
  }
  card=0;
  MemSet (&SndBack, sizeof (SndBack), 0);
  i=PrefGetAppPreferences (AppID, PREF_SND, NULL, &card, true);
  if (i!=noPreferenceFound) {
    if (card > sizeof (SndBack)) card=sizeof (SndBack);
    PrefGetAppPreferences (AppID, PREF_SND, &SndBack, &card, true);
  }

  // checking recent apps database  
  SysCurAppDatabase (&card, &locid);
  recdb=DmOpenDatabaseByTypeCreator (RecentType, AppID, dmModeReadWrite);
  if (!recdb) {
    // creating new database
    DmCreateDatabase (card, RecentName, AppID, RecentType, false);
    locid=DmFindDatabase (card, RecentName);
    if (locid) {
      DmDatabaseInfo (card, locid, NULL, &i, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      i|=dmHdrAttrBackup;
      DmSetDatabaseInfo (card, locid, NULL, &i, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    }
  } else {
    DmCloseDatabase (recdb);
  }
  // opening setup database
  locid=DmFindDatabase (card, MLapps);
  if (!locid) {
    DmCreateDatabase (card, MLapps, AppID, 'Data', true);
    locid=DmFindDatabase (card, MLapps);
    if (locid) {
      DmDatabaseInfo (card, locid, NULL, &i, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      i|=dmHdrAttrBackup;
      DmSetDatabaseInfo (card, locid, NULL, &i, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    }
  }
  // find or creation error
  if (!locid) return errorRunApp;
  cacheDB=DmOpenDatabase (card, locid, dmModeReadWrite);
  if (!cacheDB) return errorRunApp;
  // opening task database
  locid=DmFindDatabase (card, MLtasks);
  if (!locid) {
    DmCreateDatabase (card, MLtasks, AppID, 'Data', false);
    locid=DmFindDatabase (card, MLtasks);
    if (locid) {
      DmDatabaseInfo (card, locid, NULL, &i, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      i|=dmHdrAttrBackup;
      DmSetDatabaseInfo (card, locid, NULL, &i, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    }
  }
  if (!locid) return errorRunApp;
  taskDB=DmOpenDatabase (card, locid, dmModeReadWrite);
  if (!taskDB) return errorRunApp;

  // opening Treo library
  err=SysLibFind (kPmSysGadgetLibName, &gPmSysGadgetLibRefNum);
  if (err==sysErrLibNotFound)
    err=SysLibLoad (kPmSysGadgetLibType, kPmSysGadgetLibCreator, &gPmSysGadgetLibRefNum);
  if (err==errNone)
    err=PmSysGadgetLibOpen (gPmSysGadgetLibRefNum);
  if (err!=errNone)
    return cantRunApp;

  // alokace UI promennych pro task

  // seznam TASKu
  // rekl bych, ze spoleham na to, ze databaze zustane na miste... takze tasklist ukazuje primo do zaznamu...
  tasklist=MemPtrNew (sizeof (Char*)*MaxTasks);
  if (!tasklist) return errorRunApp;

  // seznam kroku
  // hlavni ukazatel by mohl byt na record a tam bych si bral binarni data
  // jenze bych musel bude dat handle nebo najit misto, kde a kdy bych ho unlocknul...
  // takze necham zatim pole textu
  steplist=MemPtrNew (sizeof (Char*)*MaxSteps);
  if (!steplist) return errorRunApp;
  steplist[0]=MemPtrNew (STEP_TITLE*MaxSteps);
  if (!steplist[0]) return errorRunApp;
  for (i=1; i<MaxSteps; i++)
    steplist[i]=&steplist[i-1][STEP_TITLE];
  // seznam akci pro kroky (jsou pouzite v listu kroku a pri editaci kroku)
  hndl = DmGetResource ('tSTL', step_actions);
  if (!hndl) return errorRunApp;
  ptr = MemHandleLock (hndl);
  i = StrLen (ptr);
  card = (ptr[i+1]<<8) + ptr[i+2];
  actions=MemPtrNew ((card+1)*sizeof (Char*));
  if (!actions) {
    MemHandleUnlock (hndl);
    DmReleaseResource (hndl);
    return errorRunApp;
  }
  actions[0]=ptr;
  actions[1]=ptr+i+3;
  i=1;
  while (i<card) {
    actions[i+1]=actions[i]+StrLen(actions[i])+1;
    i++;
  }
  // seznam eventu
  hndl=DmGetResource ('tSTL', task_events);
  if (!hndl) return errorRunApp;
  evtstr=ptr=MemHandleLock (hndl);
  i=StrLen (ptr);
  evtcnt=card = (ptr[i+1]<<8) + ptr[i+2];
  events=MemPtrNew (card*sizeof (Char*));
  if (!events) return errorRunApp;
  ptr+=i+3;
  i=0;
  while (card) {
    while (*ptr && *ptr!=':') ptr++;
    if (*ptr==':') ptr++;
    events[i++]=ptr;
    card--;
    while (*ptr) ptr++;
    ptr++;
  }
    
  return 0;
}
// ------------------------------------
// exit cleanup
// ------------------------------------
static void StopApplication (Err code) {
MemHandle       hndl;

  // closing task database
  if (taskDB) DmCloseDatabase (taskDB);
  if (tasklist!=NULL) MemPtrFree (tasklist);
//  if (steplist!=NULL) MemPtrFree (steplist);
  if (steplist!=NULL) {
    if (steplist[0]!=NULL) MemPtrFree (steplist[0]);
    MemPtrFree (steplist);
  }
  if (actions!=NULL) {
    hndl=MemPtrRecoverHandle (*actions);
    MemHandleUnlock (hndl);
    DmReleaseResource (hndl);
    MemPtrFree (actions);
  }
  if (events) MemPtrFree (events);
  if (evtstr) {
    hndl=MemPtrRecoverHandle (evtstr);
    MemHandleUnlock (hndl);
    DmReleaseResource (hndl);
  }
  // releasing apps list
  if (appslist!=NULL) MemPtrFree (appslist);
  if (apps_ptr!=NULL) MemPtrFree (apps_ptr);
  if (cacheDB) DmCloseDatabase (cacheDB);
  if (gPmSysGadgetLibRefNum!=sysInvalidRefNum)
    PmSysGadgetLibClose (gPmSysGadgetLibRefNum);
  // saving preferences
  PrefSetAppPreferences (AppID, PREF_APP, 0, &Prefs, sizeof (Prefs), true);
  PrefSetAppPreferences (AppID, PREF_SND, 0, &SndBack, sizeof (SndBack), true);
}
// ------------------------------------
// event loop
// ------------------------------------
static void EventLoop(void) {
FormPtr         form;
EventType       event;
UInt16          err;
Int32           timeout;

  timeout=2*SysTicksPerSecond ();
  do {
    EvtGetEvent (&event, timeout); //evtWaitForever);
    // obnoveni casu pri zapnuti
    if (event.eType==keyDownEvent && event.data.keyDown.chr==vchrLateWakeup)
      FrmDispatchEvent (&event);
    if (SysHandleEvent (&event)) continue;
    if (MenuHandleEvent (NULL, &event, &err)) continue;
    if (event.eType == frmLoadEvent) {
      FrmSetActiveForm (form=FrmInitForm (event.data.frmLoad.formID));
      switch (event.data.frmLoad.formID) {
	case main_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) MainFormHandler);
	  break;
	case task_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) TaskFormHandler);
	  break;
	case setup_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) SetupFormHandler);
	  break;
/**
	case lock_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) LockFormHandler);
	  break;
**/
      }
    }
    if (FrmDispatchEvent (&event)) continue;
  } while (event.eType != appStopEvent);
  FrmCloseAllForms ();
}
// ------------------------------------
// application entry point
// ------------------------------------
UInt32  PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
Err             error;

  // notification function
  if (cmd==sysAppLaunchCmdNotify) {
    return NotifyProc ((SysNotifyParamType*)cmdPBP);
  }
  //if (cmd==sysAppLaunchCmdAlarmTriggered) {
  if (cmd==sysAppLaunchCmdDisplayAlarm) {
    error=ExecAlarm ();
    return 0;
  }
  if (cmd==sysAppLaunchCmdAttention) {
    switch (((AttnLaunchCodeArgsType*)cmdPBP)->command) {
/**
      case kAttnCommandDrawDetail: // detaily pri 'insistent' pozadavku
        WinDrawChars ("detail", 6, ((AttnLaunchCodeArgsType*)cmdPBP)->commandArgsP->drawDetail.bounds.topLeft.x, ((AttnLaunchCodeArgsType*)cmdPBP)->commandArgsP->drawDetail.bounds.topLeft.y);
        break;
**/
      case kAttnCommandDrawList: // zobrazeni seznamu po drzeni stredoveho tlacitka
        WinDrawChars ("list", 4, ((AttnLaunchCodeArgsType*)cmdPBP)->commandArgsP->drawList.bounds.topLeft.x, ((AttnLaunchCodeArgsType*)cmdPBP)->commandArgsP->drawDetail.bounds.topLeft.y);
        break;
      case kAttnCommandGoThere: // skok na polozku?
        break;
      case kAttnCommandGotIt: // odskrtnuti polozky?
        break;
    }
    return 0;
  }
  // if Launcher is set to this app after reset or after downloading newer version, reregister all notifications!!
//  if (cmd==sysAppLaunchCmdSystemReset || cmd==sysAppLaunchCmdSyncNotify) {
  // it seems that it must be re-enabled only when newer version is installed but not after every hotsync...
  // so I let auto-registration for soft-reset only
  if (cmd==sysAppLaunchCmdSystemReset) { // || cmd==sysAppLaunchCmdSyncNotify) {
    if (PrefGetPreference (prefLauncherAppCreator)==AppID) {
      PrefsType lpref;
      UInt16 size=0;
      lpref.bits=MULTILAUNCHER_ON;
      if (PrefGetAppPreferences (AppID, 0, NULL, &size, true)!=noPreferenceFound) {
        if (size >sizeof (lpref)) size=sizeof (lpref);
        PrefGetAppPreferences (AppID, 0, &lpref, &size, true);
      }
      //MemopadLog ("ML_DEBUG_log\n", "ML reset\n");
      //logovani zpusobi reset!!!
      EnableMLauncher (lpref.bits);
    }
    return 0;
  }
  if (cmd!=sysAppLaunchCmdNormalLaunch && cmd!=ShowRecentList)
    return 0;
  // application start-up part
  if ((error=StartApplication ())) {
    FrmAlert (error);
    StopApplication (error);
    return error;
  }
  if (cmd==ShowRecentList)
    showRecent=true;
  // display main form
  FrmGotoForm (main_form);
//  FrmGotoForm (setup_form);
  // event loop
  EventLoop ();
  // application end routine
  StopApplication (0);
  return 0;
}
